/* PLOP!
 * (C) 1999
 * ESI/Supinfo
 * 
 * interface.c:
 * 
 * -------------------------------------------
 * 
 * Moulin Jean-Yves	(jym@ldh.org)
 * 
 * -------------------------------------------
 * 
 * This is Free Software (see COPYING for details)
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>
#ifdef HAVE_LINUX_SOUNDCARD_H
# include <linux/soundcard.h>
#else
# include <sys/soundcard.h>
#endif
#include <gtk/gtk.h>
#include "plop.h"
#include "pop3.h"
#include "conf.h"
#include "cfg.h"
#include "callback.h"
#include "interface.h"

extern _USER_RC *userrc;
extern _PLOP_RC *ploprc;


/*
 * Libere un compte
 */
void free_account(gpointer data, gpointer d)
{
	_ACCOUNT *a = (_ACCOUNT *)data;
#ifdef DEBUG
	printf("free account: %s\n", a->name);
#endif
	free(a);
}

/*
 * Check les mails sur les boites
 */
void check_all_mailbox(gint selected)
{
   
#ifdef DEBUG
	 puts("Checking account");
#endif 

	//g_list_foreach(userrc->list_account, check_account, NULL);
}


/*
 * Verifie les mails sur la boite local
 */
void check_local_mail(void)
{

}


/*
 * cree un nouveau message
 */
void mail_new(void)
{
   GtkWidget *window;

#ifdef DEBUG
	puts("Create new mail window");
#endif
	window = create_new_mail(userrc->defaultSubject, "", userrc->defaultCc, userrc->defaultBcc, NULL, 3);
	gtk_widget_show(window);
}

/*
 * Repond a un mail
 */
void mail_reply(void)
{
#ifdef DEBUG
	puts("Create reply mail window");
#endif
}

/*
 * repond a toutes les personne du mail
 */
void mail_reply_all(void)
{
#ifdef DEBUG
	puts("Create reply all mail window");
#endif
}

/*
 * transmet un mail
 */
void mail_forward(void)
{
#ifdef DEBUG
	puts("Create forward mail window");
#endif
}


/*
 * affiche le mail en entier (des header jusqu'au \n.\n)
 */
void mail_detail(GtkWidget *w, gint row)
{
#ifdef DEBUG
	puts("Create detail mail window");
#endif
}


/*
 * Fonction de trie de la list des mail
 */
void plop_list_mail_sort(GtkWidget *clist, gint column, gint *flag)
{
#ifdef DEBUG
	puts("Sort list mail");
#endif
   *flag ? gtk_clist_set_sort_type(GTK_CLIST(clist), GTK_SORT_ASCENDING) : gtk_clist_set_sort_type(GTK_CLIST(clist), GTK_SORT_DESCENDING);
   gtk_clist_set_sort_column(GTK_CLIST(clist), column);
   *flag = !*flag;
   gtk_clist_sort(GTK_CLIST(clist));
}



/*
 * Efface un mail (dans a clist, dans la glist et sur le disque
 * Si est dans poubelle. Sinon, l'envoie dans poubelle
 */
void plop_list_mail_delete_row(GtkWidget *widget)
{
//   gtk_clist_get_row_data(GTK_CLIST(*clist), ploprc->plopListMailRowSelected); remove_mail(data);
#ifdef DEBUG
	puts("Delete row in list mail");
#endif
   //gtk_clist_remove(GTK_CLIST(ploprc->plopShowedListMail), ploprc->plopListMailRowSelected);
}




/*
 * Affiche ou cache le les information to, from, date et subject de la 
 * fenetre principale
 */
void show_hide_detail_panel(GtkWidget *w)
{
   if (userrc->plopDetailPanelVisibility) {
#ifdef DEBUG
	puts("hide detail panel");
#endif
      gtk_widget_hide(ploprc->plopDetailPanel);
   } else {
#ifdef DEBUG
	puts("show detail panel");
#endif
      gtk_widget_show(ploprc->plopDetailPanel);
   }

   userrc->plopDetailPanelVisibility = !userrc->plopDetailPanelVisibility;
}



/*
 * Affiche la fenetre d'option
 */
void option_window_show(void)
{
#ifdef DEBUG
   puts("Show preference window");
#endif
   
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryName), userrc->idName);
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryEmail), userrc->idEmail);
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryOrganization), userrc->idOrganization);
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryReplyto), userrc->idReplyTo);

   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryStorageDir), userrc->dirMail);
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryAttachDir), userrc->dirAttach);
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryLocalMailDir), userrc->dirLocalMail);
   
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntrySmtpHost), userrc->smtpHost);
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntrySmtpPort), userrc->smtpPort);
   
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntrySignatureFile), userrc->signatureFile);   
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ploprc->optionButtonSignatureFile), userrc->signatureUseFile);
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryHeaderFile), userrc->headerFile);   
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ploprc->optionButtonHeaderFile), userrc->headerUseFile);

   gtk_editable_delete_text(GTK_EDITABLE(ploprc->optionEntrySignatureText), 0, gtk_text_get_length(GTK_TEXT(ploprc->optionEntrySignatureText)));
   gtk_text_insert(GTK_TEXT(ploprc->optionEntrySignatureText), NULL, NULL, NULL, userrc->signatureText, -1);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ploprc->optionButtonSignatureText), userrc->signatureUseText);
   gtk_editable_delete_text(GTK_EDITABLE(ploprc->optionEntryHeaderText), 0, gtk_text_get_length(GTK_TEXT(ploprc->optionEntryHeaderText)));
   gtk_text_insert(GTK_TEXT(ploprc->optionEntryHeaderText), NULL, NULL, NULL, userrc->headerText, -1);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ploprc->optionButtonHeaderText), userrc->headerUseText);

   gtk_option_menu_set_history(GTK_OPTION_MENU(ploprc->optionEntryEncoding), userrc->plopDefaultEncoding);
   
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryDefaultSubject), userrc->defaultSubject);
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryDefaultBcc), userrc->defaultBcc);
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryQuotingString), userrc->quotingString);
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryForwardIntro), userrc->forwardIntro);
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryForwardPrefixe), userrc->forwardPrefixe);
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryReplyIntro), userrc->replyIntro);   
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryReplyPrefixe), userrc->replyPrefixe);   
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ploprc->optionButtonQuotedReply), userrc->useQuotedReply);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ploprc->optionButtonQuotedForward), userrc->useQuotedForward);

   gtk_spin_button_set_value(GTK_SPIN_BUTTON(ploprc->optionSpinMarkRead), userrc->plopMarkRead);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ploprc->optionButtonFullAddress), userrc->plopUseFullAdress);
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryAppFtp), userrc->appFtp);
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryAppBrowser), userrc->appBrowser);
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryAppImage), userrc->appImage);
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryAppSound), userrc->appSound);
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryAppPrinter), userrc->appPrinter);
   
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryFontText), userrc->fontText);
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryFontLink), userrc->fontLink);
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryFontQuoted), userrc->fontQuoted);
   gtk_spin_button_set_value(GTK_SPIN_BUTTON(ploprc->optionSpinColorHeader), userrc->colorHeader);
   gtk_signal_emit_by_name(GTK_OBJECT(ploprc->optionSpinColorHeader), "changed");
   gtk_spin_button_set_value(GTK_SPIN_BUTTON(ploprc->optionSpinColorText), userrc->colorText);   
   gtk_signal_emit_by_name(GTK_OBJECT(ploprc->optionSpinColorText), "changed");
   gtk_spin_button_set_value(GTK_SPIN_BUTTON(ploprc->optionSpinColorQuoted), userrc->colorQuoted);   
   gtk_signal_emit_by_name(GTK_OBJECT(ploprc->optionSpinColorQuoted), "changed");
   gtk_spin_button_set_value(GTK_SPIN_BUTTON(ploprc->optionSpinColorSignature), userrc->colorSignature);
   gtk_signal_emit_by_name(GTK_OBJECT(ploprc->optionSpinColorSignature), "changed");
   gtk_spin_button_set_value(GTK_SPIN_BUTTON(ploprc->optionSpinColorLink), userrc->colorLink);
   gtk_signal_emit_by_name(GTK_OBJECT(ploprc->optionSpinColorLink), "changed");
   
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntrySoundNewMail), userrc->soundNewMail);
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntrySoundMailSent), userrc->soundMailSent);
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntrySoundError), userrc->soundError);
   
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryLogFile), userrc->plopLogFile);
   gtk_entry_set_text(GTK_ENTRY(ploprc->optionEntryGtkrcFile), userrc->plopGtkrcFile);   					     
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ploprc->optionButtonCheckStart), userrc->plopCheckStart);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ploprc->optionButtonSendAfterFetch), userrc->plopSendAfterCheck);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ploprc->optionButtonPromptTrash), userrc->plopPromptEmptyTrash);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ploprc->optionButtonEmptyTrash), userrc->plopEmptyTrashExit);
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ploprc->optionButtonLogging), userrc->plopLogUseFile);

   gtk_widget_show(GTK_WIDGET(ploprc->optionWin));
}


/*
 * Fonction utilise pour afficher les menu popups sur les dossier
 */
gint plop_folder_popup_handler(GtkWidget *widget, GdkEvent *event) 
{
   GdkEventButton *event_button = (GdkEventButton *)event;

   if (event->type == GDK_BUTTON_PRESS && event_button->button == 3) {
#ifdef DEBUG
	puts("show pop menu folder");
#endif
      gtk_menu_popup (GTK_MENU(widget), NULL, NULL, NULL, NULL, event_button->button, event_button->time);
      return TRUE;
   }
   
   return FALSE;
}


/*
 * Fonction utilise pour afficher les menu popups sur les mails
 */
gint plop_mail_popup_handler(GtkWidget *widget, GdkEvent *event) 
{
   GdkEventButton *event_button = (GdkEventButton *)event;

   if (event->type == GDK_BUTTON_PRESS && event_button->button == 3) {
#ifdef DEBUG
	puts("show pop menu mail");
#endif
      gtk_menu_popup (GTK_MENU(widget), NULL, NULL, NULL, NULL, event_button->button, event_button->time);
      return TRUE;
   }
   if (event->type == GDK_2BUTTON_PRESS) {
#ifdef DEBUG
	puts("show mail detail");
#endif
      return TRUE;
   }
   
   return FALSE;
}


/*
 * fonction utilise lorsqu'on clique sur la liste des repertoire
 */
void plop_tree_folder_select (GtkWidget *ctree, GtkCTreeNode *node)
{
   GtkWidget *book;
   gint page;

#ifdef DEBUG
	puts("plop_tree_folder_select");
#endif
   if (!GTK_CLIST(ctree)->selection)
     return;

   book = GTK_WIDGET(gtk_object_get_user_data(GTK_OBJECT(ctree)));
   page = (gint)gtk_ctree_node_get_row_data(GTK_CTREE(ctree), node);
   gtk_notebook_set_page(GTK_NOTEBOOK(book), page);
}




/*
 * Fonction utilise lorsqu'on clique sur la liste des mail affiche
 */
gint plop_list_mail_clicked(GtkWidget *clist, gint row, gint column, gpointer data)
{
#ifdef DEBUG
	puts("plop_list_mail_clicked");
#endif
   //ploprc->plopListMailRowSelected = row;
   return FALSE;
}




/*
 * Lorsqu'on deselect les mail dans la liste
 */
gint plop_list_mail_unclicked(GtkWidget *clist, gint row, gint column, gpointer data)
{
#ifdef DEBUG
	puts("plop_list_mail_unclicked");
#endif
   //ploprc->plopListMailRowSelected = 0;
   return FALSE;
}




/*
 * Pour dessiner une boite d'entree (ou on stocke les mail)
 */
void plop_draw_inbox(GtkWidget *box)
{
   gchar *titles[] = {"","Subject", "","From","Date", "size"};
   plop_create_clist(box, titles);
}

/*
 * Pour dessiner une boite de sortie (pour les mail a envoyer)
 */
void plop_draw_outbox(GtkWidget *box)
{
   gchar *titles[] = {"","Subject", "", "To","Date", "size"};
   plop_create_clist(box, titles);
}


/*
 * pour dessiner une poubelle
 */
void plop_draw_trash(GtkWidget *box)
{
   gchar *titles[] = {"","Subject", "", "From/To", "Date", "size"};
   plop_create_clist(box, titles);
}


/*
 * Pour afficher les attachement 
 */
void plop_show_attachment(GtkWidget *w, GdkEventButton *e)
{

}


/*
 * Pour redessiner le menu 'check' en rajoutant une entree par compte
 */
void plop_menu_redrawn(gpointer data, gpointer d)
{
	_ACCOUNT *account = (_ACCOUNT *)data;
	gchar buffy[50];

	//if(account->type == PROTO_POP3) { // ou PROTO_APOP ou ...
		bzero(buffy, 50);
		switch(account->type) {
			case POP3:
				snprintf(buffy, 50, "%s [pop3]", account->name);
				break;
			case IMAP:
				snprintf(buffy, 50, "%s [imap]", account->name);
				break;
		}

#ifdef DEBUG
		printf("Redraw: add %s\n", buffy);
#endif
		account->item = gtk_menu_item_new_with_label(buffy);
		gtk_widget_show(account->item);
		gtk_signal_connect_object(GTK_OBJECT(account->item), "activate", GTK_SIGNAL_FUNC(check_mailbox), (gpointer)account);
		gtk_menu_append(GTK_MENU(ploprc->plopCheckMenu), account->item);
	//}
}




/*
 * Lorsqu'on selectionne un panel d'option
 */
void option_ctree_select (GtkWidget *ctree, GtkCTreeNode *node)
{
   GtkWidget *book;
   gint page;

   if (!GTK_CLIST(ctree)->selection)
     return;

   book = GTK_WIDGET(gtk_object_get_user_data(GTK_OBJECT(ctree)));
   page = (gint)gtk_ctree_node_get_row_data(GTK_CTREE(ctree), node);

   gtk_notebook_set_page (GTK_NOTEBOOK (book), page);
}


/*
 * pour inserer un compte dans la liste des comptes afficher
 */
void option_insert_account(gpointer data, gpointer list)
{
	_ACCOUNT *account = (_ACCOUNT *)data;
	gint num;
	gchar *buffy[2];

	buffy[0] = account->name;
	switch(account->type) {
		case POP3:
			buffy[1] = "POP3";
			break;
		case IMAP:
			buffy[1] = "IMAP";
			break;
			// ou PROTO_APOP ou ...
	}


	num = gtk_clist_append(GTK_CLIST(list), buffy);
	gtk_clist_set_row_data(GTK_CLIST(list), num, (gpointer)account);
}



/*
 * Edite un compte quand on double clique sur celui-ci
 */
void option_clist_server_select(GtkCList *list, gint row, gint column, GdkEventButton *event, gpointer data)
{
	if (event->type == GDK_2BUTTON_PRESS) {
		if(GTK_CLIST(list)->selection)
			window_edit_account(gtk_clist_get_row_data(GTK_CLIST(list), row));
	}
}

/*
 * libere une struct entry et detruit la fenetre de gestion du compte
 */
void window_edit_account_close(gpointer data)
{
	_ACCOUNT_ENTRY *entry = (_ACCOUNT_ENTRY *)data;

#ifdef DEBUG
	puts("free entry->account and entry. Destroy edit window");
#endif
	gtk_widget_destroy(entry->window);
	free(entry->account);
	free(entry);
}

/*
 * TODO: efface un row de la liste, efface la struct dans la GList corrspondante
 */
void option_delete_account(GtkWidget *w, gpointer data)
{

}
/*
 * edite un compte quand on clique sur 'edit'
 * TODO: comment recuperer les donnees ??
 */
void option_edit_account(gpointer list)
{
	if(GTK_CLIST(list)->selection) {
		//g_list_foreach(GTK_CLIST(list)->selection, window_edit_account, NULL);
		//window_edit_account((GTK_CLIST(list)->selection->data));
	}
}

/*
 * Modifie la fenetre d'edition du serveur en ajoutant les option POP3
 * TODO: ajouter les options POP3
 */
void option_proto_change_pop3(gpointer data)
{
	_ACCOUNT_ENTRY *entry = (_ACCOUNT_ENTRY *)data;

	gtk_entry_set_text(GTK_ENTRY(entry->port), "110");
}


/*
 * Modifie la fenetre d'edition du serveur en ajoutant les option IMAP
 * TODO: ajouter les options IMAP
 */
void option_proto_change_imap(gpointer data)
{
	_ACCOUNT_ENTRY *entry = (_ACCOUNT_ENTRY *)data;

	gtk_entry_set_text(GTK_ENTRY(entry->port), "143");

}


void option_save_settings(gpointer data)
{
	save_rc();

	gtk_widget_hide((GtkWidget *)data);
}


/*
 * Free la structure mailEntry d'un mail et detruit la fenetre du mail
 * TODO: demander si abandon
 */
void window_mail_close(gpointer data)
{
	_MAIL_ENTRY *entry = (_MAIL_ENTRY *)data;

#ifdef DEBUG
	puts("free mailentry and destroy mail window");
#endif
	gtk_widget_destroy(entry->window);
	free(entry);
}

/*
 * Lit un WAV a 44,1khz 16bits stereo via /dev/dsp
 * TODO: Lire /dev/sndstat pour chercher les dsp
 * TODO: detection format du wav ??
 */
int oss_read_sample(gchar *sample)
{
	int sd, tmp;
	long length;
	u_char *sample_data;
	FILE *fp;

	if(!(fp = fopen(sample, "rb")))
		return -1;

	fseek(fp, 0, SEEK_END);
	length = ftell(fp);
	fseek(fp, 0, SEEK_SET);

	sample_data = malloc(length);
	fclose(fp);

	if((sd = open("/dev/dsp", O_WRONLY | O_NONBLOCK)) == -1) {
		perror("OSS open");
		return -1;
	}

	/* Taille du fragment */
	tmp = (2 << 16) + 13;
	ioctl(sd, SNDCTL_DSP_SETFRAGMENT, &tmp);
	/* format : changer en BE pour alpha... */
	tmp = AFMT_S16_LE;
	ioctl(sd, SNDCTL_DSP_SETFMT, &tmp);
	/* stereo */
	tmp = 1;
	ioctl(sd, SNDCTL_DSP_STEREO, &tmp);
	/* 16 bits */
	tmp = 16;
	ioctl(sd, SNDCTL_DSP_SAMPLESIZE, &tmp);
	/* 44,1 khz */
	tmp = 44100;
	ioctl(sd, SNDCTL_DSP_SPEED, &tmp);

	/* on joue le son */
	write(sd, (void *)sample_data, length);

	close(sd);

	return 0;
}



/*
 * Lit un WAV via ESD
 */
#ifdef HAVE_ESD_H
int esd_read_sample(gchar *sample)
{
	return 0;
}
#endif
