/* PLOP!
 * (C) 1999
 * ESI/Supinfo
 * 
 * conf.c: lecture et enregistrement des 
 * parametres...
 * 
 * -------------------------------------------
 * 
 * Moulin Jean-Yves	(jym@ldh.org)
 * 
 * -------------------------------------------
 * 
 * This is Free Software (see COPYING for details)
 */

#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <pwd.h>
#include <errno.h>
#include <gtk/gtk.h>
#include "plop.h"
#include "cfg.h"
#include "conf.h"
#include "pop3.h"


extern _PLOP_RC *ploprc;
extern _USER_RC *userrc;


_CONFIG_ROW tab_conf[] = {
	{ NULL, "/plop/directory/maildir", STR, 0, NULL },
	{ NULL, "/plop/directory/localmail", STR, 0, NULL }
};



int read_row(_CONFIG_ROW *row)
{
	switch(row->type) {
	case BOOL:
		row->value = cfg_get_bool(row->value, row->path);
		break;
	case INT:
		row->value = cfg_get_int(row->value, row->path);
		break;
	case STR:
		row->str = cfg_get_str(row->str, row->path);
		break;
	default:
		fprintf(stderr, "*** WARNING: bad settings");
		return -1;
	}

	return 0;
}



int save_row(_CONFIG_ROW *row)
{
	switch(row->type) {
		case BOOL:
			cfg_set_bool(row->value, row->path);
			break;
		case INT:
			cfg_set_int(row->value, row->path);
			break;
		case STR:
			cfg_set_str(row->str, row->path);
			break;
		default:
			fprintf(stderr, "*** WARNING: Error saving settings");
			return -1;
	}

	return 0;
}


/*
 * Lecture des parametres utilisateurs.
 * Si certains ne sont pas present, prend les valeurs par defaut.
 */
__inline__ int read_rc(void)
{
   gchar host[128];
   gchar email[128];       // email deduit de login+hostname
   gchar *mail;
   
   gethostname(host, sizeof host);
   bzero(email, 128);
   snprintf(email, 127, "%s@%s", userrc->pw->pw_name, host);


#ifdef DEBUG
   fprintf(stderr, "\tEMAIL: %s\n", email);
#endif


	/* ici tous les chargements */
   
	return 0;
}




/*
 *
 */
__inline__ void read_account(void)
{
   int number = 0;

#ifdef DEBUG
   puts("\tRead POP3 account");
#endif

   while(cfg_section_exist("/plop/POP3-%i/", number)) {
		_ACCOUNT *account = (_ACCOUNT *)malloc(sizeof(_ACCOUNT));
	   
		if (!account)
			g_error("Plop: Out of memory!\n");
	   
		account->name = cfg_get_str(NULL, "/plop/POP3-%i/name", number);
		account->type = POP3;
		account->host = cfg_get_str(NULL, "/plop/POP3-%i/host", number);
		account->port = cfg_get_str("110", "/plop/POP3-%i/port", number);
		account->username = cfg_get_str(userrc->pw->pw_name, "/plop/POP3-%i/username", number);
		account->password = cfg_get_str(NULL, "/plop/POP3-%i/password", number);
		account->delete = cfg_get_bool(0, "/plop/POP3-%i/leave_mail", number);
		account->every = cfg_get_bool(1, "/plop/POP3-%i/every", number);
		account->time = cfg_get_int(10, "/plop/POP3-%i/time", number);
		userrc->list_account = g_list_append(userrc->list_account, (gpointer)account);
	   
#ifdef DEBUG
		fprintf(stderr, "\t\tAdd: %s \n", account->name);
#endif

		if(account->every)
			account->timeout_id = gtk_timeout_add(account->time*1000*60, (void *)check_mailbox, account);
		else
			account->timeout_id = 0;
	  
		number++;
   }
   
#ifdef DEBUG
   printf("\t\tFound %i server\n", number);
   puts("\tRead IMAP account");
#endif
   
   number = 0;

	while(cfg_section_exist("/plop/IMAP-%i/", number)) {
		_ACCOUNT *account = (_ACCOUNT *)malloc(sizeof(_ACCOUNT));
	   
		if (!account)
			g_error("Plop: Out of memory!\n");
	   
		account->name = cfg_get_str(NULL, "/plop/IMAP-%i/name", number);
		account->type = IMAP;
		account->host = cfg_get_str(NULL, "/plop/IMAP-%i/host", number);
		account->port = cfg_get_str("110", "/plop/IMAP-%i/port", number);
		account->username = cfg_get_str(userrc->pw->pw_name, "/plop/IMAP-%i/username", number);
		account->password = cfg_get_str(NULL, "/plop/IMAP-%i/password", number);
		account->delete = cfg_get_bool(0, "/plop/IMAP-%i/leave_mail", number);
		account->every = cfg_get_bool(1, "/plop/IMAP-%i/every", number);
		account->time = cfg_get_int(10, "/plop/IMAP-%i/time", number);
		userrc->list_account = g_list_append(userrc->list_account, (gpointer)account);
	   
#ifdef DEBUG
		fprintf(stderr, "\t\tAdd: %s \n", account->name);
#endif

		if(account->every)
			account->timeout_id = gtk_timeout_add(account->time*1000*60, (void *)check_mailbox, account);
		else
			account->timeout_id = 0;
	  
		number++;
   }

#ifdef DEBUG
	printf("\t\tFound %i server\n", number);
#endif
}


/*
 * Initialisation des parametres utilisateurs
 */
int init_rc (void)
{
	gchar this_path[1024];  // chemin de stockage des preferences
	extern int errno;       // numero d'erreur

#ifdef DEBUG
	printf("---> init_rc...\n");
#endif

	userrc->pw = getpwnam(g_get_user_name());

	if (uname (&userrc->un))
		perror("uname");  


#ifdef DEBUG
	printf("\tLOGIN: %s\n\tHOME: %s\n\tHOSTNAME: %s\n", userrc->pw->pw_name, userrc->pw->pw_dir, userrc->un.nodename);
#endif
   
	umask(0);
	snprintf(this_path, 1023, "%s/.plop", userrc->pw->pw_dir);

#ifdef DEBUG
	printf("\tRC FILE in: %s\n", this_path);
#endif
   
	if (mkdir(this_path, (mode_t)0700)) {
		if (errno != EEXIST) {
			perror("mkdir");
			g_error("*** ERROR: Can't create %s directory!\n", this_path);
			 return -1;
		}
#ifdef DEBUG
	} else {
		fprintf(stderr, "\tCreating directory: %s\n", this_path);
#endif
	}
   
	cfg_set_home(this_path);  /* on initialise le dir du fichier de conf */
   
	read_rc();
	read_account();
	//read_dir();
	//read_rules();
#ifdef DEBUG
	puts("---> init_rc OK");
	fflush(stdout);
#endif
	return 0;
}


/*
 * Sauve les comptes
 */
void save_account(gpointer data, gpointer d)
{
	_ACCOUNT *account = (_ACCOUNT *)data;


}

/*
 *
 */
int save_rc(void)
{
#ifdef DEBUG
	puts("---> save_rc...");
#endif

	g_list_foreach(userrc->list_account, save_account, NULL);
   
	cfg_sync();

#ifdef DEBUG
	puts("---> save_rc OK");
	fflush(stdout);
#endif
	return 0;
}
