/* PLOP!
 * (C) 1999
 * ESI/Supinfo
 * 
 * conf.h: lecture et enregistrement des 
 * parametres...
 * 
 * -------------------------------------------
 * 
 * Moulin Jean-Yves	(jym@ldh.org)
 * 
 * -------------------------------------------
 * 
 * This is Free Software (see COPYING for details)
 */

#ifndef _CONF_H
#define _CONF_H

#include <sys/utsname.h>
#include <sys/types.h>

enum row_type {
	BOOL,
	INT,
	STR,
};

typedef struct {
	GtkWidget *w;
	gchar *path;
	enum row_type type;
	gint value;
	gchar *str;
} _CONFIG_ROW;


enum ssl_type {
	NEVER,
	TRY,
	ALWAYS,
};

typedef struct {
   struct passwd *pw; //login, home, shell, nom...
   struct utsname un; //uname

   GList *list_account;
   GList *list_soundcard;
   
   gchar *smtpHost; //serveur smtp
   gchar *smtpPort; //port (25)
   gint smtpUseSSL;

   gchar *idName; //nom utilisateur
   gchar *idEmail; //email
   gchar *idOrganization; //org
   gchar *idReplyTo; //reply to
   
   gchar *dirMail; //repertoire Maildir
   gchar *dirAttach; //repertoire pour attachement
   gchar *dirLocalMail; //fichier mail local
   
   gint  signatureUseFile; //utiliser un ficgier pour signature ?
   gchar *signatureFile; //emplacement fichier
   gint  signatureUseText; //uiliser texte pour signature ?
   gchar *signatureText;   //texte
   
   gint  headerUseFile; //utiliser fichier pour header ?
   gchar *headerFile; //emplacement fichier
   gint  headerUseText; //utiliser texte pour header ?
   gchar *headerText; //texte
   
   gchar *defaultSubject; //sujet par defaut
   gchar *defaultBcc; //black copie par defaut (et les autres ? to:, cc..)
   gchar *defaultCc;

   gint  useQuotedReply; //faire les reply 'quote'
   gint  useQuotedForward; //faire les forward 'quote'
   gchar *quotingString; //chaine (ou char) utilise pour 'quote'
   gchar *forwardIntro; //introduction pour forward
   gchar *forwardPrefixe; //prefixe pour sujet quand forward (ex: FW:)
   gchar *replyIntro; //introdustion pour reply
   gchar *replyPrefixe; //prefice pour sujet quand reply (ex: RE:)
   
   gchar *appBrowser; //navigateur utiliser pour url
   gchar *appFtp; //appli ftp a utiliser
   gchar *appImage; //appli pour voir images
   gchar *appPrinter; //appli a utiliser pour imprimer (ex: lpd ...)
   gchar *appSound; //appli pour ecouter son
   
   gchar *fontText; //fonte pour le texte
   gchar *fontLink; //fonte pour les liens, fichier et email
   gchar *fontQuoted; //fonte pour les lignes 'quote'
   gint  colorHeader; //couleur pour les header
   gint  colorText; //couleurs pour le texte
   gint  colorQuoted; //couleurs pour texte 'quote'
   gint  colorSignature; //couleurs pour signature
   gint  colorLink; //couleurs pour lien, fichier, email
   
   gchar *soundNewMail; //son quand new mail
   gchar *soundMailSent; //son quand mail sent
   gchar *soundError; //son quand erreur
   
   gint  plopUseFullAdress; //afficher nom + email dans la colonne from/to
   gint  plopMarkRead; //temps d'attente avant de marquer un courier comme lu
   gint  plopCheckStart; //verifier le courier qu demarrage
   gint  plopSendAfterCheck; //envoyer courier apres download
   gint  plopPromptEmptyTrash; //demander avant de vider la corbeille
   gint  plopEmptyTrashExit; //vider la corbeille en sortant
   gint  plopLogUseFile; //logguer  ?
   gchar *plopLogFile; //emplacement du fichier de log
   gchar *plopGtkrcFile; //fichier de configuration GTK+
   gint  plopDetailPanelVisibility; //afficher detail_panel ?
   gint  plopDefaultEncoding; //type d'encodage
} _USER_RC;


int save_rc(void);
int read_rc(void);
int init_rc(void);

#endif
