/* PLOP!
 * (C) 1999
 * ESI/Supinfo
 * 
 * interface.c:
 * 
 * -------------------------------------------
 * 
 * Moulin Jean-Yves	(jym@ldh.org)
 * 
 * -------------------------------------------
 * 
 * This is Free Software (see COPYING for details)
 */


#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include "callback.h"
#include "pop3.h"
#include "conf.h"
#include "plop.h"
#include "interface.h"


#ifdef USE_PIXMAP
#include "pixmaps/option_color.xpm"
#include "pixmaps/option_signature.xpm"
#include "pixmaps/option_printer.xpm"
#include "pixmaps/option_app.xpm"   
#include "pixmaps/option_header.xpm"
#include "pixmaps/option_reply.xpm"
#include "pixmaps/option_crypto.xpm"
#include "pixmaps/option_dir.xpm"
#include "pixmaps/option_ident.xpm"
#include "pixmaps/option_sound.xpm"
#include "pixmaps/option_divers.xpm"
#include "pixmaps/option_account.xpm"
#include "pixmaps/option_mail.xpm"
#include "pixmaps/option_window.xpm"

#include "pixmaps/sendNow.xpm"
#include "pixmaps/sendLater.xpm"
#include "pixmaps/save.xpm"
#include "pixmaps/attach.xpm"

#include "pixmaps/directory.xpm"
#endif
extern char *print_xpm[];
extern _USER_RC *userrc;
extern _PLOP_RC *ploprc;
static GtkWidget *fontdialog = 0;
static GtkWidget *filedialog = 0;

GdkColor colors[] =
{
  {0, 0xffff, 0xffff, 0xffff}, /* 0  white */
  {0, 0, 0, 0xffff},           /* 1 blue */
  {0, 0, 0, 0xbbbb},           /* 2 blue */
  {0, 0, 0, 0x8888},           /* 3 blue */
  {0, 0, 0xffff, 0},           /* 4  green */
  {0, 0, 0xbbbb, 0},           /* 5  light green */
  {0, 0, 0x8888, 0},           /* 6  light green */
  {0, 0xffff, 0, 0},           /* 7  red */
  {0, 0xbbbb, 0, 0},           /* 8  red */
  {0, 0x8888, 0, 0},           /* 9  red */
  {0, 0xaaaa, 0xaaaa, 0},      /* 10 yellow/brown */
  {0, 0xaaaa, 0, 0xaaaa},      /* 11 yellow/brown */
  {0, 0, 0xaaaa, 0xaaaa},      /* 12 yellow/brown */
  {0, 0xbbbb, 0, 0xbbbb},      /* 13 purple */
  {0, 0, 0xbbbb, 0xbbbb},      /* 14 aqua */
  {0, 0xbbbb, 0xbbbb, 0},      /* 15 aqua */
  {0, 0xcccc, 0xcccc, 0},      /* 16 orange */
  {0, 0xcccc, 0, 0xcccc},      /* 17 orange */
  {0, 0, 0xcccc, 0xcccc},      /* 18 orange */
  {0, 0xeeee, 0xeeee, 0},      /* 19 yellow */
  {0, 0, 0xeeee, 0xeeee},      /* 20 light aqua */
  {0, 0xeeee, 0, 0xeeee},      /* 21 aqua */
  {0, 0xffff, 0, 0xffff},      /* 22 pink */
  {0, 0, 0xffff, 0xffff},      /* 23 pink */
  {0, 0xffff, 0xffff, 0},      /* 24 pink */
  {0, 0x2222, 0x2222, 0x2222}, /* 25 grey */
  {0, 0x7777, 0x7777, 0x7777}, /* 26 grey */
  {0, 0x7777, 0x7777, 0x7777}, /* 27 grey */
  {0, 0x9999, 0x9999, 0x9999}, /* 28 light grey */
  {0, 0xf8f4, 0xffff, 0xbbbb }, /* 29 light yellow */
  {0, 0, 0, 0},                /* 30  black */
};


/* le menu de la fenetre de composition */

static GtkItemFactoryEntry compos_menu[] = {
     {"/File",                   NULL,         NULL, 0, "<Branch>"},
     {"/File/Send Now",          NULL,         NULL, 0, NULL},
     {"/File/Send Later",        NULL,         NULL, 0, NULL},
     {"/File/sep",               NULL,         NULL, 0, "<Separator>"},
     {"/File/Insert text...",    NULL,         NULL/*select_file*/, 0, NULL},
     {"/File/Save as...",        NULL,         NULL/*select_file*/, 1, NULL},
     {"/File/Print",             NULL,         NULL, 0, NULL},
     {"/File/Close",             NULL,         NULL, 0, NULL },
     {"/Edition",                NULL,         NULL, 0, "<Branch>"},
     {"/Edition/Cut",            "<control>X", NULL/*edition_menu*/, 0, NULL},
     {"/Edition/Copy",           "<control>C", NULL/*edition_menu*/, 1, NULL},
     {"/Edition/Past",           "<control>V", NULL/*edition_menu*/, 2, NULL},
     {"/Tools",                  NULL,         NULL, 0, "<Branch>"},
     {"/Tools/Attach a file...", NULL,         NULL, 0, NULL},
     {"/Tools/Priority/Very low",NULL,         NULL, 0, "<RadioItem>"},
     {"/Tools/Priority/Low",     NULL,         NULL, 0, "/Tools/Priority/Very low"},
     {"/Tools/Priority/Normal",  NULL,         NULL, 0, "/Tools/Priority/Low"},
     {"/Tools/Priority/High",    NULL,         NULL, 0, "/Tools/Priority/Low"},
     {"/Tools/Priority/Very high",NULL,         NULL, 0, "/Tools/Priority/Low"},
};



/*
 * Callback pour la fenetre de selection de font
 * met la fonte dans le GtkEntry
 */
void choose_file_ok(GtkWidget *entry)
{
   gchar *filename;
#ifdef DEBUG
   fprintf(stderr, "Update file entry...\n");
#endif
   
   filename = gtk_file_selection_get_filename(GTK_FILE_SELECTION(filedialog));
   if (filename && filename[0]) {
      gtk_entry_set_text(GTK_ENTRY(entry), filename);
   }
   gtk_widget_destroy(filedialog);
   filedialog = 0;
}


/*
 * Callback pour la fenetre de selection de fichier
 * met le nom du fichier dans le GtkEntry
 */
void choose_font_ok(GtkWidget *button, GtkWidget *entry)
{
   gchar *fontname;
#ifdef DEBUG
   fprintf(stderr, "Update font entry...\n");
#endif
   
   fontname = gtk_font_selection_dialog_get_font_name(GTK_FONT_SELECTION_DIALOG(fontdialog));
   if (fontname && fontname[0]) {
      gtk_entry_set_text(GTK_ENTRY(entry), fontname);
   }
   gtk_widget_destroy(fontdialog);
   fontdialog = 0;
}


/*
 * Callback pour les spin bouton
 * Mets a jour la couleur dans le fenetre de selection
 */
void update_color_box(GtkWidget *spin, GtkWidget *box)
{
   gint color;
   GtkStyle *style;
#ifdef DEGROBUG
   fprintf(stderr, "Update color box...\n");
#endif
   
   color = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spin));
   style = gtk_style_new();
   style->bg[0] = colors[color];
   gtk_widget_set_style(GTK_WIDGET(box), style);   
}


/*
 * Ouvre une fenetre de selection de fichier
 */
void choose_file(GtkWidget *entry)
{
   GtkWidget *dialog;
#ifdef DEBUG
   fprintf(stderr, "Show file selection dialog...\n");
#endif
   
   dialog = gtk_file_selection_new("Select file");
   gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(dialog)->ok_button), "clicked", GTK_SIGNAL_FUNC(choose_file_ok), GTK_OBJECT(entry));
   gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(dialog)->cancel_button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(dialog));
   gtk_file_selection_set_filename(GTK_FILE_SELECTION(dialog), gtk_entry_get_text(GTK_ENTRY(entry)));
   filedialog = dialog;
   gtk_widget_show(dialog);
}



/*
* Ouvre une fenetre de selection de font
*/
void choose_font(GtkWidget *entry)
{
   GtkWidget *dialog;
#ifdef DEBUG
   fprintf(stderr, "Show font selection dialog...\n");
#endif
   
   dialog = gtk_font_selection_dialog_new("Select font");
   gtk_signal_connect(GTK_OBJECT(GTK_FONT_SELECTION_DIALOG(dialog)->ok_button), "clicked", GTK_SIGNAL_FUNC(choose_font_ok), entry);
   gtk_signal_connect_object(GTK_OBJECT(GTK_FONT_SELECTION_DIALOG(dialog)->cancel_button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(dialog));
   gtk_font_selection_dialog_set_font_name(GTK_FONT_SELECTION_DIALOG(dialog), gtk_entry_get_text(GTK_ENTRY(entry)));
   fontdialog = dialog;
   gtk_widget_show(dialog);
}



/*
 * Met a jour l'encodage par defaut dans les parametres utilisateurs
 */
void set_encoding_type(gint num)
{
   userrc->plopDefaultEncoding = num;
}



/*
 * Met a jour le nom de la fenetre de composition de mail
 * pour qu'elle est comme titre le sujet du mail
 * BUG: quand le sujet est compose d'espace
 */
gint set_window_title (GtkWidget *item, GtkWidget *window)
{
   gchar *tmp;
   tmp = gtk_entry_get_text(GTK_ENTRY(item));
   (tmp == NULL || tmp == "" || strlen(tmp) == 0) ? gtk_window_set_title(GTK_WINDOW(window), "No subject") : gtk_window_set_title(GTK_WINDOW(window), tmp);
   return FALSE;
}




/*
 * Cree une nouvelle fenetre de composition de mail
 */
GtkWidget *create_new_mail (gchar *subject, gchar *to, gchar *cc, gchar *bcc, _ATTACH *attachment, gint priority)
{
   GtkWidget *vbox, *hbox, *item, *toolbar, *button_sendNow, *button_sendLater, *button_save, *button_print, *button_attach, *button_to, *label, *menu_close, *scrolledwindow;
   GtkItemFactory *item_factory;
   GtkAccelGroup *accel_group;
#ifdef USE_PIXMAP
   GtkWidget *pixmap;
   GdkPixmap *xpm;
   GdkBitmap *mask;
#endif

   _MAIL_ENTRY *mailEntry = (_MAIL_ENTRY *)malloc(sizeof(_MAIL_ENTRY));
   
   mailEntry->window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
   gtk_window_set_default_size(GTK_WINDOW(mailEntry->window), 400, 300);
   gtk_widget_set_usize (mailEntry->window, 180, 60);
   gtk_window_set_title (GTK_WINDOW (mailEntry->window), "No subject");
   gtk_signal_connect_object(GTK_OBJECT(mailEntry->window), "delete_event", GTK_SIGNAL_FUNC(window_mail_close), (gpointer)mailEntry);
   gtk_widget_realize(mailEntry->window);
   
   vbox = gtk_vbox_new(FALSE, 0);
   gtk_widget_show(vbox);
   gtk_container_add(GTK_CONTAINER(mailEntry->window), vbox);

   accel_group = gtk_accel_group_new();
   item_factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<main>", accel_group);
   gtk_item_factory_create_items(item_factory, 19, compos_menu, NULL);
   gtk_accel_group_attach(accel_group, GTK_OBJECT(mailEntry->window));
   
   item = gtk_item_factory_get_widget(item_factory, "<main>");
   menu_close = gtk_item_factory_get_widget(item_factory, "/File/Close");
   gtk_box_pack_start (GTK_BOX (vbox), item, FALSE, FALSE, 0);
   gtk_signal_connect_object(GTK_OBJECT(menu_close), "activate", GTK_SIGNAL_FUNC(window_mail_close), (gpointer)mailEntry);
   gtk_widget_show(item);
   
   toolbar = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_ICONS);
   gtk_widget_show (toolbar);
   gtk_container_border_width (GTK_CONTAINER (toolbar), 2);
   gtk_toolbar_set_button_relief (GTK_TOOLBAR (toolbar), GTK_RELIEF_NONE);
   gtk_toolbar_set_space_style (GTK_TOOLBAR(toolbar), 1);
   gtk_toolbar_set_space_size (GTK_TOOLBAR (toolbar), 10);
   gtk_box_pack_start (GTK_BOX (vbox), toolbar, FALSE, FALSE, 0);
   
   
   xpm = gdk_pixmap_create_from_xpm_d (mailEntry->window->window, &mask, &mailEntry->window->style->bg[GTK_STATE_NORMAL], sendNow_xpm);
   pixmap = gtk_pixmap_new (xpm, mask);
   button_sendNow = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_CHILD_BUTTON, NULL, "Send now", "Send message now", NULL, pixmap, NULL, NULL);
   gtk_widget_show (button_sendNow);
   
   xpm = gdk_pixmap_create_from_xpm_d (mailEntry->window->window, &mask, NULL, sendLater_xpm);
   pixmap = gtk_pixmap_new (xpm, mask);
   button_sendLater = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_CHILD_BUTTON, NULL, "Send later", "Send message later", "private tooltip", pixmap, NULL, NULL);
   gtk_widget_show (button_sendLater);
   
   gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));
   
   xpm = gdk_pixmap_create_from_xpm_d (mailEntry->window->window, &mask, NULL, save_xpm);
   pixmap = gtk_pixmap_new (xpm, mask);
   button_save = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_CHILD_BUTTON, NULL, "Save", "Save message as file", NULL, pixmap, NULL, NULL);
   gtk_widget_show (button_save);
//   gtk_signal_connect(GTK_OBJECT(button_save), "clicked", GTK_SIGNAL_FUNC(select_file), (gpointer)1);
   
   xpm = gdk_pixmap_create_from_xpm_d (mailEntry->window->window, &mask, NULL, print_xpm);
   pixmap = gtk_pixmap_new (xpm, mask);
   button_print = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_CHILD_BUTTON, NULL, "Print", "Print message", NULL, pixmap, NULL, NULL);
   gtk_widget_show (button_print);
   
   gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));
   
   xpm = gdk_pixmap_create_from_xpm_d (mailEntry->window->window, &mask, NULL, attach_xpm);
   pixmap = gtk_pixmap_new (xpm, mask);
   button_attach = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_CHILD_BUTTON, NULL, "Attach", "Attach a file", NULL, pixmap, NULL, NULL);
   gtk_widget_show (button_attach);
   
   hbox = gtk_hbox_new(FALSE, 0);
   gtk_widget_show(hbox);
   gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
   
   
   button_to = gtk_button_new_with_label ("To:");
   gtk_widget_show (button_to);
   gtk_box_pack_start (GTK_BOX (hbox), button_to, FALSE, FALSE, 2);
   gtk_button_set_relief(GTK_BUTTON(button_to), GTK_RELIEF_NONE);
   gtk_widget_set_usize(button_to, 60, -2);
   
   mailEntry->entryTo = gtk_entry_new ();
   gtk_widget_show (mailEntry->entryTo);
   gtk_box_pack_start (GTK_BOX (hbox), mailEntry->entryTo, TRUE, TRUE, 0);
   if (to)
     gtk_entry_set_text(GTK_ENTRY(mailEntry->entryTo), to);
   

      
   hbox = gtk_hbox_new(FALSE, 0);
   gtk_widget_show(hbox);
   gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
   
   label = gtk_button_new_with_label ("CC:");
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 2);
   gtk_button_set_relief(GTK_BUTTON(label), GTK_RELIEF_NONE);
   gtk_widget_set_usize(label, 60, -2);
   
   mailEntry->entryCc = gtk_entry_new ();
   gtk_widget_show (mailEntry->entryCc);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), mailEntry->entryCc);

   // a finir
   label = gtk_button_new_with_label ("BCC:");
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 2);
   gtk_button_set_relief(GTK_BUTTON(label), GTK_RELIEF_NONE);
   gtk_widget_set_usize(label, 60, -2);
   
   mailEntry->entryBcc = gtk_entry_new ();
   gtk_widget_show (mailEntry->entryBcc);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), mailEntry->entryBcc);


   
   hbox = gtk_hbox_new(FALSE, 0);
   gtk_widget_show(hbox);
   gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
   
   label = gtk_label_new ("Subject:");
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 2);
   gtk_widget_set_usize(label, 60, -2);
   
   mailEntry->entrySubject = gtk_entry_new ();
   gtk_widget_show (mailEntry->entrySubject);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), mailEntry->entrySubject);
   gtk_entry_set_text(GTK_ENTRY(mailEntry->entrySubject), subject);
   gtk_signal_connect(GTK_OBJECT(mailEntry->entrySubject), "changed", GTK_SIGNAL_FUNC(set_window_title), (gpointer)mailEntry->window);


   scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
   gtk_widget_show(scrolledwindow);
   gtk_box_pack_start_defaults (GTK_BOX (vbox), scrolledwindow);
   gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
   
   mailEntry->text = gtk_text_new (NULL, NULL);
   gtk_widget_show(mailEntry->text);
   gtk_text_set_editable(GTK_TEXT(mailEntry->text), TRUE);
   gtk_container_add (GTK_CONTAINER (scrolledwindow), mailEntry->text);


   scrolledwindow = gtk_scrolled_window_new(NULL, NULL);
   gtk_widget_show(scrolledwindow);
   gtk_box_pack_end(GTK_BOX(vbox), scrolledwindow, FALSE, FALSE, 0);
   gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
   
   mailEntry->listAttach = gtk_list_new();
   gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrolledwindow), mailEntry->listAttach);
   gtk_widget_show(mailEntry->listAttach);
   
//   gtk_signal_connect_object(GTK_OBJECT(button_sendNow), "clicked", GTK_SIGNAL_FUNC(send_mail), (gpointer)mailEntry);

   
   return mailEntry->window;
}





/*
 * Cree et montre la fenetre 'about'
 */
void show_about(void)
{
   GtkWidget *window;
   GtkWidget *vbox;
   GtkWidget *label;
   GtkWidget *info_boite;
   GtkWidget *bouton_close_info;
   GtkWidget *hbox;
   gchar buf[512];
   GtkStyle *about_style;
   GtkStyle *head_style;
   
#ifdef DEGROBUG
   fprintf(stderr, "Creating about window...\n");
#endif

   head_style = gtk_style_new ();
   head_style->font = gdk_font_load ("-adobe-new century schoolbook-bold-r-normal-*-*-240-*-*-p-*-iso8859-1");
   if (!head_style->font)
     head_style->font = gdk_font_load ("fixed");
   memcpy (head_style->fg, &colors[1], sizeof (GdkColor));
   memcpy (head_style->bg, &colors[0], sizeof (GdkColor));
   
   about_style = gtk_style_new ();
   about_style->font = gdk_font_load ("fixed");
   
   window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
   gtk_grab_add(window);
   gtk_window_set_title (GTK_WINDOW (window), "Plop: About...");
   gtk_window_set_policy (GTK_WINDOW (window), FALSE, FALSE, FALSE);
   gtk_signal_connect(GTK_OBJECT(window), "destroy", GTK_SIGNAL_FUNC(gtk_widget_destroy), NULL);
   gtk_signal_connect(GTK_OBJECT(window), "delete_event", GTK_SIGNAL_FUNC(gtk_widget_destroy), NULL);
   gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER);
   
   vbox = gtk_vbox_new (FALSE, 0);
   gtk_widget_show (vbox);
   gtk_container_add (GTK_CONTAINER (window), vbox);
   
   label = gtk_entry_new ();
   gtk_entry_set_editable (GTK_ENTRY (label), FALSE);
   gtk_entry_set_text (GTK_ENTRY (label), "             Plop! " VERSION);
   gtk_widget_set_style (label, head_style);
   gtk_container_add (GTK_CONTAINER (vbox), label);
   gtk_widget_show (label);
   

   snprintf (buf, sizeof buf,
	     "         This programm is Free Software\n"
	     "              WITHOUT ANY WARRANTY\n\n"
             "  Build ................. : " __DATE__ "\n"
             "  GTK+ Version .......... : %d.%d.%d\n"
             "  Systeme ............... : %s %s [%s]\n"
             "  Homepage: ............. : http://jym.free.fr\n"
             "  E-mail ................ : jym@ldh.org\n", gtk_major_version, gtk_minor_version, gtk_micro_version, userrc->un.sysname, userrc->un.release, userrc->un.machine);

   info_boite = gtk_label_new (buf);
   gtk_label_set_justify (GTK_LABEL (info_boite), GTK_JUSTIFY_LEFT);
   gtk_widget_set_style (info_boite, about_style);
   gtk_widget_show (info_boite);
   gtk_box_pack_start (GTK_BOX (vbox), info_boite, TRUE, TRUE, 0);
   gtk_misc_set_padding (GTK_MISC (info_boite), 5, 5);
   
   hbox = gtk_hbutton_box_new ();
   gtk_widget_show (hbox);
   gtk_box_pack_end (GTK_BOX (vbox), hbox, FALSE, TRUE, 0);
   gtk_container_border_width (GTK_CONTAINER (hbox), 5);
   gtk_button_box_set_layout (GTK_BUTTON_BOX (hbox), GTK_BUTTONBOX_END);
   gtk_button_box_set_spacing (GTK_BUTTON_BOX (hbox), 5);
   
   bouton_close_info = gtk_button_new_with_label ("Close");
   gtk_container_add (GTK_CONTAINER (hbox), bouton_close_info);
   gtk_widget_show (bouton_close_info);
   
   gtk_signal_connect_object (GTK_OBJECT (bouton_close_info), "clicked", GTK_SIGNAL_FUNC(gtk_grab_remove), GTK_OBJECT(window));
   gtk_signal_connect_object (GTK_OBJECT (bouton_close_info), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (window));
   
   
   GTK_WIDGET_SET_FLAGS (bouton_close_info, GTK_CAN_DEFAULT);
   gtk_widget_grab_default (bouton_close_info);
   
   gtk_widget_show(window);
}


/*
 * Cree le popup menu pour la liste des mails
 */
GtkWidget *plop_create_popup_menu_mail(void)
{
   GtkWidget *menuitem;
   GtkWidget *menu;
   GtkWidget *MainMenu;

   MainMenu = gtk_menu_new();
   
   menuitem = gtk_tearoff_menu_item_new();
   gtk_menu_append(GTK_MENU(MainMenu), menuitem);
   gtk_widget_show(menuitem);
   
   menuitem = gtk_menu_item_new_with_label("Reply");
   gtk_menu_append(GTK_MENU(MainMenu), menuitem);
   gtk_widget_show(menuitem);
   gtk_widget_set_sensitive(menuitem, FALSE);
   
   menuitem = gtk_menu_item_new_with_label("Reply to all");
   gtk_widget_set_sensitive(menuitem, FALSE);
   gtk_menu_append(GTK_MENU(MainMenu), menuitem);
   gtk_widget_show(menuitem);
   
   menuitem = gtk_menu_item_new_with_label("Forward");
   gtk_widget_set_sensitive(menuitem, FALSE);
   gtk_menu_append(GTK_MENU(MainMenu), menuitem);
   gtk_widget_show(menuitem);
   
   menuitem = gtk_menu_item_new();
   gtk_widget_set_sensitive(menuitem, FALSE);
   gtk_menu_append(GTK_MENU(MainMenu), menuitem);
   gtk_widget_show(menuitem);
   
   menu = gtk_menu_new();
   menuitem = gtk_menu_item_new_with_label("Sort by...");
   gtk_menu_append(GTK_MENU(MainMenu), menuitem);
   gtk_widget_show(menuitem);
   gtk_menu_item_set_submenu (GTK_MENU_ITEM (menuitem), menu);
   
   menuitem = gtk_menu_item_new_with_label("By date");
   gtk_menu_append(GTK_MENU(menu), menuitem);
   gtk_signal_connect(GTK_OBJECT(menuitem), "activate", GTK_SIGNAL_FUNC(plop_list_mail_sort), (gint *)3);
   gtk_widget_show(menuitem);
   
   menuitem = gtk_menu_item_new_with_label("By subject");
   gtk_menu_append(GTK_MENU(menu), menuitem);
   gtk_signal_connect(GTK_OBJECT(menuitem), "activate", GTK_SIGNAL_FUNC(plop_list_mail_sort), (gint *)1);
   gtk_widget_show(menuitem);
   
   menuitem = gtk_menu_item_new_with_label("By sender");
   gtk_menu_append(GTK_MENU(menu), menuitem);
   gtk_signal_connect(GTK_OBJECT(menuitem), "activate", GTK_SIGNAL_FUNC(plop_list_mail_sort), (gint *)2);
   gtk_widget_show(menuitem);
   
   menuitem = gtk_menu_item_new_with_label("Save as...");
   gtk_widget_set_sensitive(menuitem, FALSE);
   gtk_menu_append(GTK_MENU(MainMenu), menuitem);
   gtk_widget_show(menuitem);
   
   menuitem = gtk_menu_item_new_with_label("Print");
   gtk_widget_set_sensitive(menuitem, FALSE);
   gtk_menu_append(GTK_MENU(MainMenu), menuitem);
   gtk_widget_show(menuitem);
   
   menuitem = gtk_menu_item_new_with_label("Delete");
   gtk_menu_append(GTK_MENU(MainMenu), menuitem);
   gtk_signal_connect(GTK_OBJECT(menuitem), "activate", GTK_SIGNAL_FUNC(plop_list_mail_delete_row), NULL);
   gtk_widget_show(menuitem);
   
   menuitem = gtk_menu_item_new();
   gtk_widget_set_sensitive(menuitem, FALSE);
   gtk_menu_append(GTK_MENU(MainMenu), menuitem);
   gtk_widget_show(menuitem);
   
   menuitem = gtk_menu_item_new_with_label("Mark as read");
   gtk_widget_set_sensitive(menuitem, FALSE);
   gtk_menu_append(GTK_MENU(MainMenu), menuitem);
   gtk_widget_show(menuitem);
   
   menuitem = gtk_menu_item_new_with_label("Mark as unread");
   gtk_widget_set_sensitive(menuitem, FALSE);
   gtk_menu_append(GTK_MENU(MainMenu), menuitem);
   gtk_widget_show(menuitem);
   
   menuitem = gtk_menu_item_new();
   gtk_widget_set_sensitive(menuitem, FALSE);
   gtk_menu_append(GTK_MENU(MainMenu), menuitem);
   gtk_widget_show(menuitem);
   
   menuitem = gtk_menu_item_new_with_label("Properties");
   gtk_widget_set_sensitive(menuitem, FALSE);
   gtk_menu_append(GTK_MENU(MainMenu), menuitem);
   gtk_widget_show(menuitem);
   
   return MainMenu;
}

/*
 * Cree le popup menu pour les repertoires
 */
GtkWidget *plop_create_popup_menu_dir(void)
{
   GtkWidget *menuitem;
   GtkWidget *MainMenu;
   
   MainMenu = gtk_menu_new();
   
   menuitem = gtk_tearoff_menu_item_new();
   gtk_menu_append(GTK_MENU(MainMenu), menuitem);
   gtk_widget_show(menuitem);
   
   menuitem = gtk_menu_item_new_with_label("New dir");
   gtk_widget_set_sensitive(menuitem, FALSE);
   gtk_menu_append(GTK_MENU(MainMenu), menuitem);
   gtk_widget_show(menuitem);
   
   menuitem = gtk_menu_item_new_with_label("Delete");
   gtk_widget_set_sensitive(menuitem, FALSE);
   gtk_menu_append(GTK_MENU(MainMenu), menuitem);
   gtk_widget_show(menuitem);
   
   menuitem = gtk_menu_item_new();
   gtk_widget_set_sensitive(menuitem, FALSE);
   gtk_menu_append(GTK_MENU(MainMenu), menuitem);
   gtk_widget_show(menuitem);
   
   menuitem = gtk_menu_item_new_with_label("Rename");
   gtk_widget_set_sensitive(menuitem, FALSE);
   gtk_menu_append(GTK_MENU(MainMenu), menuitem);
   gtk_widget_show(menuitem);
   
   menuitem = gtk_menu_item_new_with_label("Empty");
   gtk_widget_set_sensitive(menuitem, FALSE);
   gtk_menu_append(GTK_MENU(MainMenu), menuitem);
   gtk_widget_show(menuitem);
   
   menuitem = gtk_menu_item_new_with_label("Mark all as read");
   gtk_widget_set_sensitive(menuitem, FALSE);
   gtk_menu_append(GTK_MENU(MainMenu), menuitem);
   gtk_widget_show(menuitem);
   
   return MainMenu;
}

/*
 * Cree une page avec une clist pour un nouveau repertoire
 */
GtkWidget * plop_create_page (GtkWidget *book, GtkWidget *ctree, gchar *tree_label, GtkCTreeNode *parent, GtkCTreeNode **node, gint page_index, void (* draw)(GtkWidget *), gchar *pixmap[])
{
   GtkWidget *vbox;
#ifdef USE_PIXMAP
   GdkPixmap *xpm;
   GdkBitmap *mask;
   GdkColor  transparent;
#endif

   gchar *titles[1];

   vbox = gtk_vbox_new (FALSE, 0);
   gtk_container_set_border_width (GTK_CONTAINER (vbox), 0);
   gtk_widget_show (vbox);

   titles[0] = tree_label;

   if(pixmap)
     xpm = gdk_pixmap_create_from_xpm_d (ploprc->plopWin->window, &mask, &transparent, pixmap);
   else
     xpm = gdk_pixmap_create_from_xpm_d (ploprc->plopWin->window, &mask, &transparent, directory_xpm);

   *node = gtk_ctree_insert_node (GTK_CTREE (ctree), parent, NULL, titles, 4,
                                  xpm, mask, xpm, mask, FALSE, TRUE);
   gtk_ctree_node_set_row_data (GTK_CTREE (ctree), *node,
                                (gpointer) page_index);

   if (draw)
     draw(vbox);

   gtk_notebook_append_page (GTK_NOTEBOOK (book), vbox, NULL);
   return vbox;
}


/*
 * Cree une clist pour presenter le contenu d'un repertoire
 */
void plop_create_clist(GtkWidget *box, gchar *titles[])
{
   GtkWidget *grmbl, *scrolled_win;
   
   scrolled_win = gtk_scrolled_window_new (NULL, NULL);
   gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_win), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
   gtk_container_add(GTK_CONTAINER(box), scrolled_win);
   gtk_widget_show(scrolled_win);

   grmbl = gtk_clist_new_with_titles (6, titles);
   gtk_container_add(GTK_CONTAINER(scrolled_win), grmbl);
   gtk_clist_set_selection_mode (GTK_CLIST (grmbl), GTK_SELECTION_EXTENDED);
   gtk_signal_connect(GTK_OBJECT(grmbl), "select-row", GTK_SIGNAL_FUNC(plop_list_mail_clicked), NULL);
   gtk_signal_connect(GTK_OBJECT(grmbl), "unselect-row", GTK_SIGNAL_FUNC(plop_list_mail_unclicked), NULL);

   gtk_clist_set_column_width (GTK_CLIST (grmbl), 0, 18);
   gtk_clist_set_column_resizeable (GTK_CLIST (grmbl), 0, FALSE);

   gtk_clist_set_column_width (GTK_CLIST (grmbl), 1, 178);
   gtk_clist_set_column_min_width (GTK_CLIST (grmbl), 1, 70);

   gtk_clist_set_column_width (GTK_CLIST (grmbl), 2, 18);
   gtk_clist_set_column_resizeable (GTK_CLIST (grmbl), 2, FALSE);
   
   gtk_clist_set_column_width (GTK_CLIST (grmbl), 3, 145);
   gtk_clist_set_column_min_width (GTK_CLIST (grmbl), 3, 60);
   
   gtk_clist_set_column_width (GTK_CLIST (grmbl), 4, 80);
   gtk_clist_set_column_min_width (GTK_CLIST (grmbl), 4, 50);
   
   gtk_clist_set_column_width (GTK_CLIST (grmbl), 5, 40);
   gtk_clist_set_column_min_width (GTK_CLIST (grmbl), 5, 30);
   
   gtk_clist_set_row_height(GTK_CLIST(grmbl), 14);
   
   gtk_signal_connect(GTK_OBJECT(grmbl), "click-column", GTK_SIGNAL_FUNC(plop_list_mail_sort), (gpointer)&ploprc->plopListMailSortFlag);
   gtk_signal_connect_object(GTK_OBJECT(grmbl), "button_press_event", GTK_SIGNAL_FUNC (plop_mail_popup_handler), GTK_OBJECT(ploprc->plopPopupMenuMail));
   gtk_widget_show(grmbl);
}


/*
 * Cree une page pour la fenetre d'option
 */
GtkWidget * settings_create_page (GtkWidget *book, gchar *book_label, GtkWidget *ctree,
                      gchar *tree_label, GtkCTreeNode *parent,
                      GtkCTreeNode **node, gint page_index, void (* draw)(GtkWidget *))
{
   GtkWidget *frame;
   GtkWidget *label;
   GtkWidget *vvbox;
   GtkWidget *vbox;

   gchar *titles[1];

   vvbox = gtk_vbox_new (FALSE, 0);
   gtk_widget_show (vvbox);

   frame = gtk_frame_new (NULL);
   gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_OUT);
   gtk_box_pack_start (GTK_BOX (vvbox), frame, FALSE, TRUE, 0);
   gtk_widget_show (frame);

   label = gtk_label_new (book_label);
   gtk_misc_set_alignment (GTK_MISC (label), 0.0, 0.5);
   gtk_misc_set_padding (GTK_MISC (label), 2, 1);
   gtk_container_add (GTK_CONTAINER (frame), label);
   gtk_widget_show (label);

   vbox = gtk_vbox_new (FALSE, 2);
   gtk_container_set_border_width (GTK_CONTAINER (vbox), 4);
   gtk_container_add (GTK_CONTAINER (vvbox), vbox);
   gtk_widget_show (vbox);

   titles[0] = tree_label;
   *node = gtk_ctree_insert_node (GTK_CTREE (ctree), parent, NULL, titles, 0,
                                  NULL, NULL, NULL, NULL, FALSE, TRUE);
   gtk_ctree_node_set_row_data (GTK_CTREE (ctree), *node,
                                (gpointer) page_index);

   if (draw)
     draw(vbox);

   gtk_notebook_append_page (GTK_NOTEBOOK (book), vvbox, NULL);
   return vbox;
}


/**************************************/
/* les options: */


/*
 * les reglages generaux
 */
void draw_general_settings(GtkWidget *box)
{  
   GtkWidget *hbox, *label, *menu, *item;
   GtkAdjustment *adj;

#ifdef USE_PIXMAP
   GtkWidget *pixmap;
   GdkPixmap *xpm;
   GdkBitmap *mask;
   GdkColor  transparent;
#endif

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);

#ifdef USE_PIXMAP   
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->optionWin->window,  &mask, &transparent, option_divers_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
   gtk_widget_show(pixmap);
   gtk_box_pack_start(GTK_BOX(hbox), pixmap, FALSE, FALSE, 0);
#endif

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
  
   ploprc->optionButtonCheckStart = gtk_check_button_new_with_label("Check for mail on startup.");
   gtk_widget_show(ploprc->optionButtonCheckStart);
   gtk_box_pack_start_defaults(GTK_BOX(hbox), ploprc->optionButtonCheckStart);
   /* A REMPLACER */
   gtk_widget_set_usize(ploprc->optionButtonCheckStart, 180, -2);
     
   ploprc->optionButtonSendAfterFetch = gtk_check_button_new_with_label("Sent usent after fetch.");
   gtk_widget_show(ploprc->optionButtonSendAfterFetch);
   gtk_box_pack_end_defaults(GTK_BOX(hbox), ploprc->optionButtonSendAfterFetch);
   /* A REMPLACER */
   gtk_widget_set_usize(ploprc->optionButtonSendAfterFetch, 180, -2);
  

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);

   ploprc->optionButtonPromptTrash = gtk_check_button_new_with_label("Prompt before emptying trash.");
   gtk_widget_show(ploprc->optionButtonPromptTrash);
   gtk_box_pack_start_defaults(GTK_BOX(hbox), ploprc->optionButtonPromptTrash);
   gtk_widget_set_usize(ploprc->optionButtonPromptTrash, 80, -2);
   
   ploprc->optionButtonEmptyTrash = gtk_check_button_new_with_label("Empty trash on exit.");
   gtk_widget_show(ploprc->optionButtonEmptyTrash);
   gtk_box_pack_end_defaults(GTK_BOX(hbox), ploprc->optionButtonEmptyTrash);
   /* A REMPLACER */
   gtk_widget_set_usize(ploprc->optionButtonEmptyTrash, 80, -2);


   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   ploprc->optionButtonFullAddress = gtk_check_button_new_with_label("Always show email with name.");
   gtk_widget_show(ploprc->optionButtonFullAddress);
   gtk_box_pack_start_defaults(GTK_BOX(hbox), ploprc->optionButtonFullAddress);
   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);

   /* a finir (pas sauvegarder) */   
   ploprc->optionButtonAutoCheck = gtk_check_button_new_with_label("Disable auto check (for all account).");
   gtk_widget_show(ploprc->optionButtonAutoCheck);
   gtk_box_pack_start_defaults(GTK_BOX(hbox), ploprc->optionButtonAutoCheck);

   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   ploprc->optionButtonLogging = gtk_check_button_new_with_label ("Log I/O in file:");
   gtk_widget_show (ploprc->optionButtonLogging);
   gtk_box_pack_start(GTK_BOX (hbox), ploprc->optionButtonLogging, FALSE, FALSE, 0);
   /* A REMPLACER */
   gtk_widget_set_usize(ploprc->optionButtonLogging, 140, -2);
   
   ploprc->optionEntryLogFile = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryLogFile);
   gtk_box_pack_start_defaults(GTK_BOX (hbox), ploprc->optionEntryLogFile);
   
   label = gtk_button_new_with_label("...");
   gtk_widget_show(label);
   gtk_box_pack_start (GTK_BOX(hbox), label, FALSE, TRUE, 0);
   gtk_signal_connect_object(GTK_OBJECT(label), "clicked", GTK_SIGNAL_FUNC(choose_file), GTK_OBJECT(ploprc->optionEntryLogFile));


   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
     
   label = gtk_label_new ("Ressource file for GTK:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   /* A REMPLACER */
   gtk_widget_set_usize(label, 140, -2);
   gtk_box_pack_start(GTK_BOX (hbox), label, FALSE, FALSE, 0);
   
   ploprc->optionEntryGtkrcFile = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryGtkrcFile);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryGtkrcFile);
   
   label = gtk_button_new_with_label("...");
   gtk_widget_show(label);
   gtk_box_pack_start (GTK_BOX(hbox), label, FALSE, TRUE, 0);
   gtk_signal_connect_object(GTK_OBJECT(label), "clicked", GTK_SIGNAL_FUNC(choose_file), GTK_OBJECT(ploprc->optionEntryGtkrcFile));

   

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);

   label = gtk_label_new ("Encoding:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_widget_set_usize(label, 140, -2);
   gtk_box_pack_start(GTK_BOX (hbox), label, FALSE, FALSE, 0);

   ploprc->optionEntryEncoding = gtk_option_menu_new();
   menu = gtk_menu_new();

   item = gtk_menu_item_new_with_label("MIME/Base64");
   gtk_signal_connect_object(GTK_OBJECT(item), "activate", set_encoding_type, (gpointer)0);
   gtk_widget_show(item); 
   gtk_menu_append(GTK_MENU(menu), item);

   item = gtk_menu_item_new_with_label("UUE");
   gtk_signal_connect_object(GTK_OBJECT(item), "activate", set_encoding_type, (gpointer)1);
   gtk_widget_show(item); 
   gtk_menu_append(GTK_MENU(menu), item);
   
   item = gtk_menu_item_new_with_label("Quoted Printable");
   gtk_signal_connect_object(GTK_OBJECT(item), "activate", set_encoding_type, (gpointer)2);
   gtk_widget_show(item); 
   gtk_menu_append(GTK_MENU(menu), item);
   
   item = gtk_menu_item_new_with_label("Binary 8bits (no encoding)");
   gtk_signal_connect_object(GTK_OBJECT(item), "activate", set_encoding_type, (gpointer)3);
   gtk_widget_show(item); 
   gtk_menu_append(GTK_MENU(menu), item);

   gtk_option_menu_set_menu(GTK_OPTION_MENU(ploprc->optionEntryEncoding), menu);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryEncoding);
   gtk_widget_show(ploprc->optionEntryEncoding);
   

   adj = (GtkAdjustment *)gtk_adjustment_new(5.0, 0.0, 60.0, 1.0, 5.0, 0.0);
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
     
   label = gtk_label_new ("Mark message read after:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 140, -2);
   
   ploprc->optionSpinMarkRead = gtk_spin_button_new(adj, 0, 0);
   gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(ploprc->optionSpinMarkRead), TRUE);
   gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(ploprc->optionSpinMarkRead), GTK_SHADOW_OUT);
   gtk_widget_show (ploprc->optionSpinMarkRead);
   gtk_box_pack_start (GTK_BOX (hbox), ploprc->optionSpinMarkRead, FALSE, TRUE, 0);

   label = gtk_label_new("  seconds.");
   gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
   gtk_widget_show(label);

}




/*
 * Nom, email, organisation et reply-to.
 */
void draw_identity_settings(GtkWidget *box)
{
   GtkWidget *hbox, *label;
   GtkWidget *pixmap;
   GdkPixmap *xpm;
   GdkBitmap *mask;
   GdkColor  transparent;


   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);

#ifdef USE_PIXMAP   
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->optionWin->window,  &mask, &transparent, option_ident_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
   gtk_widget_show(pixmap);
   gtk_box_pack_start(GTK_BOX(hbox), pixmap, FALSE, FALSE, 0);
#endif
   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_label_new ("Name:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 100, -2);
   
   ploprc->optionEntryName = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryName);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryName);
   

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_label_new ("E-mail:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 100, -2);
   
   ploprc->optionEntryEmail = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryEmail);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryEmail);
   
   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_label_new ("Reply-to adress:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 100, -2);
   
   ploprc->optionEntryReplyto = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryReplyto);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryReplyto);


   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_label_new ("Organization:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 100, -2);
   
   ploprc->optionEntryOrganization = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryOrganization);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryOrganization);
}


   
/*
 * les repertoires.
 */
void draw_directory_settings(GtkWidget *box)
{
   GtkWidget *hbox, *label;
   
#ifdef USE_PIXMAP
   GtkWidget *pixmap;
   GdkPixmap *xpm;
   GdkBitmap *mask;
   GdkColor  transparent;
#endif

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);

#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->optionWin->window,  &mask, &transparent, option_dir_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
   gtk_widget_show(pixmap);
   gtk_box_pack_start(GTK_BOX(hbox), pixmap, FALSE, FALSE, 0);
#endif
   
   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
      
   label = gtk_label_new ("Local mail directory:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 120, -2);
   
   ploprc->optionEntryLocalMailDir = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryLocalMailDir);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryLocalMailDir);
   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_label_new ("Mail directory:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 120, -2);

   ploprc->optionEntryStorageDir = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryStorageDir);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryStorageDir);
   
   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_label_new ("Attachments directory:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 120, -2);

   ploprc->optionEntryAttachDir = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryAttachDir);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryAttachDir);
}


   

void draw_colorfont_settings(GtkWidget *box)
{  
   GtkWidget *hbox, *label;
   GtkAdjustment *adj;

#ifdef USE_PIXMAP
   GtkWidget *pixmap;
   GdkPixmap *xpm;
   GdkBitmap *mask;
   GdkColor  transparent;
#endif

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);

#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->optionWin->window,  &mask, &transparent, option_color_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
   gtk_widget_show(pixmap);
   gtk_box_pack_start(GTK_BOX(hbox), pixmap, FALSE, FALSE, 0);
#endif

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_label_new ("Font for normal text:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 130, -2);

   ploprc->optionEntryFontText = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryFontText);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryFontText);

   label = gtk_button_new_with_label("...");
   gtk_widget_show(label);
   gtk_box_pack_start (GTK_BOX(hbox), label, FALSE, TRUE, 0);
   gtk_signal_connect_object(GTK_OBJECT(label), "clicked", GTK_SIGNAL_FUNC(choose_font), GTK_OBJECT(ploprc->optionEntryFontText));
   
   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_label_new ("Font for quoted text:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 130, -2);

   ploprc->optionEntryFontQuoted = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryFontQuoted);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryFontQuoted);

   label = gtk_button_new_with_label("...");
   gtk_widget_show(label);
   gtk_box_pack_start (GTK_BOX(hbox), label, FALSE, TRUE, 0);
   gtk_signal_connect_object(GTK_OBJECT(label), "clicked", GTK_SIGNAL_FUNC(choose_font), GTK_OBJECT(ploprc->optionEntryFontQuoted));

   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_label_new ("Font for link & email:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 130, -2);

   ploprc->optionEntryFontLink = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryFontLink);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryFontLink);

   label = gtk_button_new_with_label("...");
   gtk_widget_show(label);
   gtk_box_pack_start (GTK_BOX(hbox), label, FALSE, TRUE, 0);
   gtk_signal_connect_object(GTK_OBJECT(label), "clicked", GTK_SIGNAL_FUNC(choose_font), GTK_OBJECT(ploprc->optionEntryFontLink));


   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_label_new ("Color for header:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 130, -2);
   
   label = gtk_event_box_new ();
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, TRUE, 0);
   gtk_widget_set_usize (label, 40, 22);

   adj = (GtkAdjustment *)gtk_adjustment_new((gfloat)userrc->colorHeader, 0.0, NUMBER_OF_COLOR, 1.0, 5.0, 0.0);
   ploprc->optionSpinColorHeader = gtk_spin_button_new(adj, 0, 0);
   gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(ploprc->optionSpinColorHeader), TRUE);
   gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(ploprc->optionSpinColorHeader), GTK_SHADOW_OUT);
   gtk_widget_show (ploprc->optionSpinColorHeader);
   gtk_box_pack_end (GTK_BOX (hbox), ploprc->optionSpinColorHeader, FALSE, TRUE, 0);
   gtk_signal_connect(GTK_OBJECT(ploprc->optionSpinColorHeader), "changed", GTK_SIGNAL_FUNC(update_color_box), label);
   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_label_new ("Color for signature:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 130, -2);

   label = gtk_event_box_new ();
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, TRUE, 0);
   gtk_widget_set_usize (label, 40, 22);

   adj = (GtkAdjustment *)gtk_adjustment_new((gfloat)userrc->colorSignature, 0.0, NUMBER_OF_COLOR, 1.0, 5.0, 0.0);
   ploprc->optionSpinColorSignature = gtk_spin_button_new(adj, 0, 0);
   gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(ploprc->optionSpinColorSignature), TRUE);
   gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(ploprc->optionSpinColorSignature), GTK_SHADOW_OUT);
   gtk_widget_show (ploprc->optionSpinColorSignature);
   gtk_box_pack_end (GTK_BOX (hbox), ploprc->optionSpinColorSignature, FALSE, TRUE, 0);
   gtk_signal_connect(GTK_OBJECT(ploprc->optionSpinColorSignature), "changed", GTK_SIGNAL_FUNC(update_color_box), label);
   
      
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_label_new ("Color for text:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 130, -2);

   label = gtk_event_box_new ();
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, TRUE, 0);
   gtk_widget_set_usize (label, 40, 22);

   adj = (GtkAdjustment *)gtk_adjustment_new((gfloat)userrc->colorText, 0.0, NUMBER_OF_COLOR, 1.0, 5.0, 0.0);
   ploprc->optionSpinColorText = gtk_spin_button_new(adj, 0, 0);
   gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(ploprc->optionSpinColorText), TRUE);
   gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(ploprc->optionSpinColorText), GTK_SHADOW_OUT);
   gtk_widget_show (ploprc->optionSpinColorText);
   gtk_box_pack_end (GTK_BOX (hbox), ploprc->optionSpinColorText, FALSE, TRUE, 0);
   gtk_signal_connect(GTK_OBJECT(ploprc->optionSpinColorText), "changed", GTK_SIGNAL_FUNC(update_color_box), label);

   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_label_new ("Color for quoted text:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 130, -2);

   label = gtk_event_box_new ();
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, TRUE, 0);
   gtk_widget_set_usize (label, 40, 22);

   adj = (GtkAdjustment *)gtk_adjustment_new((gfloat)userrc->colorQuoted, 0.0, NUMBER_OF_COLOR, 1.0, 5.0, 0.0);
   ploprc->optionSpinColorQuoted = gtk_spin_button_new(adj, 0, 0);
   gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(ploprc->optionSpinColorQuoted), TRUE);
   gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(ploprc->optionSpinColorQuoted), GTK_SHADOW_OUT);
   gtk_widget_show (ploprc->optionSpinColorQuoted);
   gtk_box_pack_end (GTK_BOX (hbox), ploprc->optionSpinColorQuoted, FALSE, TRUE, 0);
   gtk_signal_connect(GTK_OBJECT(ploprc->optionSpinColorQuoted), "changed", GTK_SIGNAL_FUNC(update_color_box), label);


   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_label_new ("Color for link:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 130, -2);
   
   label = gtk_event_box_new ();
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, TRUE, 0);
   gtk_widget_set_usize (label, 40, 22);

   adj = (GtkAdjustment *)gtk_adjustment_new((gfloat)userrc->colorHeader, 0.0, NUMBER_OF_COLOR, 1.0, 5.0, 0.0);
   ploprc->optionSpinColorLink = gtk_spin_button_new(adj, 0, 0);
   gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(ploprc->optionSpinColorLink), TRUE);
   gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(ploprc->optionSpinColorLink), GTK_SHADOW_OUT);
   gtk_widget_show (ploprc->optionSpinColorLink);
   gtk_box_pack_end (GTK_BOX (hbox), ploprc->optionSpinColorLink, FALSE, TRUE, 0);
   gtk_signal_connect(GTK_OBJECT(ploprc->optionSpinColorLink), "changed", GTK_SIGNAL_FUNC(update_color_box), label);
}


   
   




/*
 * les applications
 */
void draw_application_settings(GtkWidget *box)
{
   GtkWidget *hbox, *label;

#ifdef USE_PIXMAP
   GtkWidget *pixmap;
   GdkPixmap *xpm;
   GdkBitmap *mask;
   GdkColor  transparent;
#endif

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->optionWin->window,  &mask, &transparent, option_app_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
   gtk_widget_show(pixmap);
   gtk_box_pack_start(GTK_BOX(hbox), pixmap, FALSE, FALSE, 0);
#endif

   label = gtk_label_new("Specify application command line:");
   gtk_widget_show(label);
   gtk_box_pack_start_defaults(GTK_BOX(hbox), label);


   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);

   label = gtk_label_new ("HTTP:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 100, -2);
   
   ploprc->optionEntryAppBrowser = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryAppBrowser);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryAppBrowser);


   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);

   label = gtk_label_new ("FTP:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 100, -2);
   
   ploprc->optionEntryAppFtp = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryAppFtp);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryAppFtp);

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);

   label = gtk_label_new ("Image viewer:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 100, -2);
   
   ploprc->optionEntryAppImage = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryAppImage);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryAppImage);

   
   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);

   label = gtk_label_new ("Sound player:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 100, -2);
   
   ploprc->optionEntryAppSound = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryAppSound);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryAppSound);   
}


/*
 * Pour imprimer
 */
void draw_printer_settings(GtkWidget *box)
{
   GtkWidget *hbox, *label;

#ifdef USE_PIXMAP
   GtkWidget *pixmap;
   GdkPixmap *xpm;
   GdkBitmap *mask;
   GdkColor  transparent;
#endif

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->optionWin->window,  &mask, &transparent, option_printer_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
   gtk_widget_show(pixmap);
   gtk_box_pack_start(GTK_BOX(hbox), pixmap, FALSE, FALSE, 0);
#endif

   label = gtk_label_new("Specify application command line:");
   gtk_widget_show(label);
   gtk_box_pack_start_defaults(GTK_BOX(hbox), label);


   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);

   label = gtk_label_new ("Printing:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 100, -2);
   
   ploprc->optionEntryAppPrinter = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryAppPrinter);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryAppPrinter);
}


/*
 * les sons
 */
void draw_sound_settings(GtkWidget *box)
{   
   GtkWidget *hbox, *label;

#ifdef USE_PIXMAP
   GtkWidget *pixmap;
   GdkPixmap *xpm;
   GdkBitmap *mask;
   GdkColor  transparent;
#endif
   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->optionWin->window,  &mask, &transparent, option_sound_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
   gtk_widget_show(pixmap);
   gtk_box_pack_start(GTK_BOX(hbox), pixmap, FALSE, FALSE, 0);
#endif


   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
     
   label = gtk_label_new ("Sound for new mail:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 120, -2);
   
   ploprc->optionEntrySoundNewMail = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntrySoundNewMail);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntrySoundNewMail);

   label = gtk_button_new_with_label("...");
   gtk_widget_show(label);
   gtk_box_pack_start (GTK_BOX(hbox), label, FALSE, TRUE, 0);
   gtk_signal_connect_object(GTK_OBJECT(label), "clicked", GTK_SIGNAL_FUNC(choose_file), GTK_OBJECT(ploprc->optionEntrySoundNewMail));



   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
     
   label = gtk_label_new ("Sound when error:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 120, -2);
   
   ploprc->optionEntrySoundError = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntrySoundError);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntrySoundError);

   label = gtk_button_new_with_label("...");
   gtk_widget_show(label);
   gtk_box_pack_start (GTK_BOX(hbox), label, FALSE, TRUE, 0);
   gtk_signal_connect_object(GTK_OBJECT(label), "clicked", GTK_SIGNAL_FUNC(choose_file), GTK_OBJECT(ploprc->optionEntrySoundError));


   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
     
   label = gtk_label_new ("Sound for mail sent:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 120, -2);
   
   ploprc->optionEntrySoundMailSent = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntrySoundMailSent);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntrySoundMailSent);

   label = gtk_button_new_with_label("...");
   gtk_widget_show(label);
   gtk_box_pack_start (GTK_BOX(hbox), label, FALSE, TRUE, 0);
   gtk_signal_connect_object(GTK_OBJECT(label), "clicked", GTK_SIGNAL_FUNC(choose_file), GTK_OBJECT(ploprc->optionEntrySoundMailSent));
}





/*
 * reglages de messages
 */
void draw_recept_settings(GtkWidget *box)
{  
   GtkWidget *hbox, *label;

#ifdef USE_PIXMAP
   GtkWidget *pixmap;
   GdkPixmap *xpm;
   GdkBitmap *mask;
   GdkColor  transparent;
#endif

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);

#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->optionWin->window,  &mask, &transparent, option_reply_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
   gtk_widget_show(pixmap);
   gtk_box_pack_start(GTK_BOX(hbox), pixmap, FALSE, FALSE, 0);
#endif

   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
     
   label = gtk_label_new ("Default subject:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 120, -2);
   
   ploprc->optionEntryDefaultSubject = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryDefaultSubject);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryDefaultSubject);


   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_label_new ("Default BCC:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 120, -2);
   
   ploprc->optionEntryDefaultBcc = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryDefaultBcc);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryDefaultBcc);


   // ce qui suit n'est pas sauvegarder
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_label_new ("Wrap lines at: :");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 120, -2);
   
   label = gtk_entry_new ();
   gtk_widget_show (label);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), label);


   /* rajouter 'send HTML or plain text'   wrap lines at (72)...*/

}




/*
 * pour regler les reply
 */
void draw_sendreply_settings(GtkWidget *box)
{  
   GtkWidget *hbox, *label;

#ifdef USE_PIXMAP
   GtkWidget *pixmap;
   GdkPixmap *xpm;
   GdkBitmap *mask;
   GdkColor  transparent;
#endif

        
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);

#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->optionWin->window,  &mask, &transparent, option_mail_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
   gtk_widget_show(pixmap);
   gtk_box_pack_start(GTK_BOX(hbox), pixmap, FALSE, FALSE, 0);
#endif

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_label_new ("The original message should be inserted quoted :");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_widget_set_usize(label, 250, 25);
   gtk_box_pack_start(GTK_BOX (hbox), label, FALSE, FALSE, 0);

   ploprc->optionButtonQuotedReply = gtk_check_button_new_with_label("In reply.");
   gtk_widget_show(ploprc->optionButtonQuotedReply);
   gtk_box_pack_end_defaults(GTK_BOX(hbox), ploprc->optionButtonQuotedReply);

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_event_box_new();
   gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize(label, 250, -2);
   gtk_widget_show(label);

   ploprc->optionButtonQuotedForward = gtk_check_button_new_with_label("In forward.");
   gtk_widget_show(ploprc->optionButtonQuotedForward);
   gtk_box_pack_end_defaults(GTK_BOX(hbox), ploprc->optionButtonQuotedForward);

   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
     
   label = gtk_label_new ("String for quoting:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 120, -2);
   
   ploprc->optionEntryQuotingString = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryQuotingString);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryQuotingString);

   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_label_new ("Replying prefixe:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 120, -2);
   
   ploprc->optionEntryReplyPrefixe = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryReplyPrefixe);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryReplyPrefixe);

   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_label_new ("Replying intro:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 120, -2);
   
   ploprc->optionEntryReplyIntro = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryReplyIntro);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryReplyIntro);

   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_label_new ("Forwarding prefixe:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 120, -2);
   
   ploprc->optionEntryForwardPrefixe = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryForwardPrefixe);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryForwardPrefixe);
   
   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_label_new ("Forwarding intro:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 120, -2);
   
   ploprc->optionEntryForwardIntro = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryForwardIntro);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryForwardIntro);

   
   label = gtk_label_new ("Introduction string can be composed with:\n%s = subject; %nl = newline; %w = sender; %d = date");
   gtk_widget_show (label);
   gtk_box_pack_start(GTK_BOX (box), label, FALSE, FALSE, 0);

}






/*
 * Les signatures.
 */
void draw_signature_settings(GtkWidget *box)
{
   GtkWidget *hbox, *vbox, *label;
   GtkTooltips *tips;

#ifdef USE_PIXMAP
   GtkWidget *pixmap;
   GdkPixmap *xpm;
   GdkBitmap *mask;
   GdkColor  transparent;
#endif
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->optionWin->window,  &mask, &transparent, option_signature_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
   gtk_widget_show(pixmap);
   gtk_box_pack_start(GTK_BOX(hbox), pixmap, FALSE, FALSE, 0);
#endif
/*   
   label = gtk_label_new("Automatically add in your messages:"); // anglais ca ?
   gtk_widget_show(label);
   gtk_box_pack_start_defaults(GTK_BOX(hbox), label);
*/
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   ploprc->optionButtonSignatureProg = gtk_check_button_new_with_label("Execute:");
   gtk_widget_show(ploprc->optionButtonSignatureProg);
   gtk_box_pack_start(GTK_BOX(hbox), ploprc->optionButtonSignatureProg, FALSE, FALSE, 0);
   tips = gtk_tooltips_new();
   gtk_tooltips_set_tip(tips, ploprc->optionButtonSignatureProg, "Plop will use the stdout of this prog as signature", "A REMPLACER");
   gtk_widget_set_usize(ploprc->optionButtonSignatureProg, 100, -2);
   
   ploprc->optionEntrySignatureProg = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntrySignatureProg);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntrySignatureProg);

   label = gtk_button_new_with_label("...");
   gtk_widget_show(label);
   gtk_box_pack_start (GTK_BOX(hbox), label, FALSE, TRUE, 0);
   gtk_signal_connect_object(GTK_OBJECT(label), "clicked", GTK_SIGNAL_FUNC(choose_file), GTK_OBJECT(ploprc->optionEntrySignatureProg));

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   ploprc->optionButtonSignatureFile = gtk_check_button_new_with_label("Include file:");
   gtk_widget_show(ploprc->optionButtonSignatureFile);
   gtk_box_pack_start(GTK_BOX(hbox), ploprc->optionButtonSignatureFile, FALSE, FALSE, 0);
   gtk_widget_set_usize(ploprc->optionButtonSignatureFile, 100, -2);
   
   ploprc->optionEntrySignatureFile = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntrySignatureFile);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntrySignatureFile);

   label = gtk_button_new_with_label("...");
   gtk_widget_show(label);
   gtk_box_pack_start (GTK_BOX(hbox), label, FALSE, TRUE, 0);
   gtk_signal_connect_object(GTK_OBJECT(label), "clicked", GTK_SIGNAL_FUNC(choose_file), GTK_OBJECT(ploprc->optionEntrySignatureFile));
   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   
   vbox = gtk_vbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(hbox), vbox, FALSE, FALSE, 0);
   gtk_widget_set_usize(vbox, 100, -2);
   gtk_widget_show(vbox);
   
   ploprc->optionButtonSignatureText = gtk_check_button_new_with_label("This:");
   gtk_widget_show(ploprc->optionButtonSignatureText);
   gtk_box_pack_start(GTK_BOX(vbox), ploprc->optionButtonSignatureText, FALSE, FALSE, 0);
   gtk_widget_set_usize(ploprc->optionButtonSignatureText, 100, -2);

   ploprc->optionEntrySignatureText = gtk_text_new (NULL, NULL);
   gtk_widget_show(ploprc->optionEntrySignatureText);
   gtk_text_set_editable(GTK_TEXT(ploprc->optionEntrySignatureText), TRUE);
   gtk_container_add (GTK_CONTAINER (hbox), ploprc->optionEntrySignatureText);

}




/*
 * Les en-tetes
 */
void draw_header_settings(GtkWidget *box)
{  
   GtkWidget *hbox, *label, *vbox;
   GtkTooltips *tips;
   
#ifdef USE_PIXMAP
   GtkWidget *pixmap;
   GdkPixmap *xpm;
   GdkBitmap *mask;
   GdkColor  transparent;
#endif

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->optionWin->window,  &mask, &transparent, option_header_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
   gtk_widget_show(pixmap);
   gtk_box_pack_start(GTK_BOX(hbox), pixmap, FALSE, FALSE, 0);
#endif

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   ploprc->optionButtonHeaderProg = gtk_check_button_new_with_label("Execute:");
   gtk_widget_show(ploprc->optionButtonHeaderProg);
   gtk_box_pack_start(GTK_BOX(hbox), ploprc->optionButtonHeaderProg, FALSE, FALSE, 0);
   tips = gtk_tooltips_new();
   gtk_tooltips_set_tip(tips, ploprc->optionButtonHeaderProg, "Plop will use the stdout of this prog as signature", "A REMPLACER");
   gtk_widget_set_usize(ploprc->optionButtonHeaderProg, 100, -2);
   
   ploprc->optionEntryHeaderProg = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryHeaderProg);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryHeaderProg);

   label = gtk_button_new_with_label("...");
   gtk_widget_show(label);
   gtk_box_pack_start (GTK_BOX(hbox), label, FALSE, TRUE, 0);
   gtk_signal_connect_object(GTK_OBJECT(label), "clicked", GTK_SIGNAL_FUNC(choose_file), GTK_OBJECT(ploprc->optionEntryHeaderProg));


   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   ploprc->optionButtonHeaderFile = gtk_check_button_new_with_label("Include file:");
   gtk_widget_show(ploprc->optionButtonHeaderFile);
   gtk_box_pack_start(GTK_BOX(hbox), ploprc->optionButtonHeaderFile, FALSE, FALSE, 0);
   gtk_widget_set_usize(ploprc->optionButtonHeaderFile, 100, -2);
   
   ploprc->optionEntryHeaderFile = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntryHeaderFile);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntryHeaderFile);

   label = gtk_button_new_with_label("...");
   gtk_widget_show(label);
   gtk_box_pack_start (GTK_BOX(hbox), label, FALSE, TRUE, 0);
   gtk_signal_connect_object(GTK_OBJECT(label), "clicked", GTK_SIGNAL_FUNC(choose_file), GTK_OBJECT(ploprc->optionEntryHeaderFile));

   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);

   vbox = gtk_vbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(hbox), vbox, FALSE, FALSE, 0);
   gtk_widget_set_usize(vbox, 100, -2);
   gtk_widget_show(vbox);
   
   ploprc->optionButtonHeaderText = gtk_check_button_new_with_label("This:");
   gtk_widget_show(ploprc->optionButtonHeaderText);
   gtk_box_pack_start(GTK_BOX(vbox), ploprc->optionButtonHeaderText, FALSE, FALSE, 0);
   gtk_widget_set_usize(ploprc->optionButtonHeaderText, 100, -2);

   ploprc->optionEntryHeaderText = gtk_text_new (NULL, NULL);
   gtk_widget_show(ploprc->optionEntryHeaderText);
   gtk_text_set_editable(GTK_TEXT(ploprc->optionEntryHeaderText), TRUE);
   gtk_container_add (GTK_CONTAINER (hbox), ploprc->optionEntryHeaderText);

}




/*
 * pour PGP et GPG
 */
void draw_security_settings(GtkWidget *box)
{   
   GtkWidget *hbox, *label;

#ifdef USE_PIXMAP
   GtkWidget *pixmap;
   GdkPixmap *xpm;
   GdkBitmap *mask;
   GdkColor  transparent;
#endif
   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);

#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->optionWin->window,  &mask, &transparent, option_crypto_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
   gtk_widget_show(pixmap);
   gtk_box_pack_start(GTK_BOX(hbox), pixmap, FALSE, FALSE, 0);
#endif

   label = gtk_label_new("PGP and GPG");
   gtk_widget_show(label);
   gtk_box_pack_start_defaults(GTK_BOX(hbox), label);

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   label = gtk_check_button_new_with_label("Use a password:");
   gtk_widget_show(label);
   gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
   
   label = gtk_entry_new ();
   gtk_widget_show (label);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), label);

}




/*
 * pour les epplets
 */
void draw_window_settings(GtkWidget *box)
{   
   GtkWidget *hbox, *label;

#ifdef USE_PIXMAP
   GtkWidget *pixmap;
   GdkPixmap *xpm;
   GdkBitmap *mask;
   GdkColor  transparent;
#endif
   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);

#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->optionWin->window,  &mask, &transparent, option_window_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
   gtk_widget_show(pixmap);
   gtk_box_pack_start(GTK_BOX(hbox), pixmap, FALSE, FALSE, 0);
#endif

   label = gtk_label_new("Other window");
   gtk_widget_show(label);
   gtk_box_pack_start_defaults(GTK_BOX(hbox), label);
}



/*
 * les comptes pop et imap
 */
void draw_account_settings(GtkWidget *box)
{
   GtkWidget *hbox, *label, *toolbar;
   GtkWidget *button_add_server, *button_edit_server, *button_delete_server, *scrolled_win;

#ifdef USE_PIXMAP
   GtkWidget *pixmap;
   GdkPixmap *xpm;
   GdkBitmap *mask;
   GdkColor  transparent;
#endif

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->optionWin->window,  &mask, &transparent, option_account_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
   gtk_widget_show(pixmap);
   gtk_box_pack_start(GTK_BOX(hbox), pixmap, FALSE, FALSE, 0);
#endif
   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);
   
   toolbar = gtk_vbutton_box_new ();
   gtk_widget_show (toolbar);
   gtk_box_pack_start (GTK_BOX (hbox), toolbar, FALSE, TRUE, 0);
   gtk_button_box_set_layout (GTK_BUTTON_BOX (toolbar), GTK_BUTTONBOX_SPREAD);
   gtk_button_box_set_child_size(GTK_BUTTON_BOX(toolbar), 40, 18);
   gtk_button_box_set_spacing(GTK_BUTTON_BOX(toolbar), 25);
   
   /* boutton ADD */
   button_add_server = gtk_button_new_with_label ("Add");
   gtk_widget_show (button_add_server);
   gtk_container_add (GTK_CONTAINER (toolbar), button_add_server);


   /* boutton EDIT */
   button_edit_server = gtk_button_new_with_label ("Edit");
   gtk_widget_show (button_edit_server);
   gtk_container_add (GTK_CONTAINER (toolbar), button_edit_server);


   /* Boutton DELETE */
   button_delete_server = gtk_button_new_with_label ("Delete");
   gtk_widget_show (button_delete_server);
   gtk_container_add (GTK_CONTAINER (toolbar), button_delete_server);


   /* CLIST des serveurs */
   scrolled_win = gtk_scrolled_window_new (NULL, NULL);
   gtk_widget_show(scrolled_win);
   gtk_box_pack_start_defaults(GTK_BOX(hbox), scrolled_win);
   gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_win), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
   gtk_container_set_border_width (GTK_CONTAINER (scrolled_win), 5);

   ploprc->optionListServer = gtk_clist_new(2);
   gtk_widget_show (ploprc->optionListServer);
   gtk_clist_set_selection_mode (GTK_CLIST (ploprc->optionListServer), GTK_SELECTION_BROWSE);
   gtk_clist_set_column_width (GTK_CLIST (ploprc->optionListServer), 0, 200);
   gtk_clist_column_titles_show (GTK_CLIST (ploprc->optionListServer));
	gtk_clist_set_column_resizeable(GTK_CLIST(ploprc->optionListServer), 0, FALSE);
	gtk_clist_set_column_resizeable(GTK_CLIST(ploprc->optionListServer), 1, FALSE);
   gtk_clist_column_titles_passive(GTK_CLIST(ploprc->optionListServer));

   label = gtk_label_new ("Name");
   gtk_widget_show (label);
   gtk_clist_set_column_widget (GTK_CLIST (ploprc->optionListServer), 0, label);
   gtk_widget_set_usize(GTK_WIDGET(label), -2, 12);
   label = gtk_label_new ("Type");
   gtk_widget_show (label);
   gtk_clist_set_column_widget (GTK_CLIST (ploprc->optionListServer), 1, label);
   gtk_widget_set_usize(GTK_WIDGET(label), -2, 12);
   gtk_container_add(GTK_CONTAINER(scrolled_win), ploprc->optionListServer);

   gtk_clist_clear(GTK_CLIST(ploprc->optionListServer));
   g_list_foreach(userrc->list_account, option_insert_account, ploprc->optionListServer);

   gtk_signal_connect(GTK_OBJECT(button_delete_server), "clicked", GTK_SIGNAL_FUNC(option_delete_account), NULL);
   gtk_signal_connect_object(GTK_OBJECT(button_add_server), "clicked", GTK_SIGNAL_FUNC(window_edit_account), NULL);
   gtk_signal_connect_object(GTK_OBJECT(button_edit_server), "clicked", GTK_SIGNAL_FUNC(option_edit_account), GTK_OBJECT(ploprc->optionListServer));
   gtk_signal_connect(GTK_OBJECT(ploprc->optionListServer), "select_row", GTK_SIGNAL_FUNC(option_clist_server_select), NULL);
}
   

/*
 * le smtp
 */
void draw_smtp_settings(GtkWidget *box)
{   
   GtkWidget *hbox, *label;
   
#ifdef USE_PIXMAP
   GtkWidget *pixmap;
   GdkPixmap *xpm;
   GdkBitmap *mask;
   GdkColor  transparent;
#endif

   
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);

#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->optionWin->window,  &mask, &transparent, option_account_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
   gtk_widget_show(pixmap);
   gtk_box_pack_start(GTK_BOX(hbox), pixmap, FALSE, FALSE, 0);
#endif

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);

   label = gtk_label_new ("SMTP server:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 120, -2);
   
   ploprc->optionEntrySmtpHost = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntrySmtpHost);
   gtk_box_pack_start_defaults (GTK_BOX (hbox), ploprc->optionEntrySmtpHost);

   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);

   label = gtk_label_new ("SMTP port:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 120, -2);
   
   ploprc->optionEntrySmtpPort = gtk_entry_new ();
   gtk_widget_show (ploprc->optionEntrySmtpPort);
   gtk_box_pack_start (GTK_BOX (hbox), ploprc->optionEntrySmtpPort, FALSE, FALSE, 0);
   gtk_widget_set_usize(ploprc->optionEntrySmtpPort, 50, -2);

   
   // ce qui suit n'est pas sauvegarder
   hbox = gtk_hbox_new (FALSE, 0);
   gtk_widget_show (hbox);
   gtk_box_pack_start(GTK_BOX (box), hbox, FALSE, FALSE, 0);

   label = gtk_label_new ("Use SSL:");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize (label, 120, -2);

   label = gtk_radio_button_new_with_label(NULL, "Never");
   // par defaut:
   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(label), 1);
   gtk_widget_show(label);
   gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize(label, 100, -2);

   label = gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(label)), "If possible");
   gtk_widget_show(label);
   gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize(label, 100, -2);

   label = gtk_radio_button_new_with_label(gtk_radio_button_group(GTK_RADIO_BUTTON(label)), "Always");
   gtk_widget_show(label);
   gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
   gtk_widget_set_usize(label, 100, -2);
}





void create_option_window(void)
{
   GtkCTreeNode *top, *child;
   GtkWidget *hbox, *vbox, *ctree, *frame, *book, *label, *entire_widget;
   gint index;
   gchar *titles[1];
    
#ifdef DEGROBUG
   fprintf(stderr, "Creating option window...\n");
#endif
  
   ploprc->optionWin = gtk_window_new (GTK_WINDOW_TOPLEVEL);
   gtk_window_set_title (GTK_WINDOW (ploprc->optionWin), "Plop: Preferences");
   gtk_window_set_policy(GTK_WINDOW(ploprc->optionWin), FALSE, FALSE, FALSE);
   gtk_signal_connect_object(GTK_OBJECT(ploprc->optionWin), "delete_event", gtk_widget_hide, GTK_OBJECT(ploprc->optionWin));
   gtk_widget_set_usize(GTK_WIDGET(ploprc->optionWin), 550, 315);
   gtk_widget_realize(ploprc->optionWin);
      
   entire_widget = gtk_vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(ploprc->optionWin), entire_widget);
   gtk_widget_show(entire_widget);
   
   
   hbox = gtk_hbox_new(FALSE, 6);
   gtk_container_set_border_width(GTK_CONTAINER(hbox), 6);
   gtk_box_pack_start(GTK_BOX(entire_widget), hbox, TRUE, TRUE, 0);
   gtk_widget_show(hbox);
   
   titles[0] = "Settings";
   ctree = gtk_ctree_new_with_titles (1, 0, titles);
   gtk_clist_column_titles_passive(GTK_CLIST(ctree));
   gtk_clist_set_selection_mode (GTK_CLIST (ctree), GTK_SELECTION_BROWSE);
   gtk_ctree_set_indent (GTK_CTREE (ctree), 15);
   gtk_widget_set_usize (ctree, 140, 0);
   gtk_box_pack_start (GTK_BOX (hbox), ctree, FALSE, FALSE, 0);
   gtk_widget_show (ctree);
   /* pour faire bo */
   gtk_ctree_set_line_style(GTK_CTREE(ctree), GTK_CTREE_LINES_NONE);
   gtk_ctree_set_expander_style(GTK_CTREE(ctree), GTK_CTREE_EXPANDER_TRIANGLE);
   
   frame = gtk_frame_new (NULL);
   gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_IN);
   gtk_box_pack_start (GTK_BOX (hbox), frame, TRUE, TRUE, 0);
   gtk_widget_show (frame);

   book = gtk_notebook_new ();
   gtk_notebook_set_show_tabs (GTK_NOTEBOOK (book), FALSE);
   gtk_notebook_set_show_border (GTK_NOTEBOOK (book), FALSE);
   gtk_container_add (GTK_CONTAINER (frame), book);
   gtk_object_set_user_data (GTK_OBJECT (ctree), book);
   gtk_signal_connect (GTK_OBJECT (ctree), "tree_select_row", 
		       GTK_SIGNAL_FUNC (option_ctree_select), NULL);
   index = 0;

   vbox = settings_create_page (book, "Incomming mail", ctree, "Mail server", NULL, &top, index++,
				draw_account_settings);
   vbox = settings_create_page (book, "Outgoing mail", ctree, "Mail relay", NULL, &top, index++,
				draw_smtp_settings);

   
   vbox = settings_create_page (book, "Mail client settings", ctree, "Plop! settings", NULL, &top, index++, 
				draw_general_settings);

   gtk_ctree_select (GTK_CTREE (ctree), top);

   vbox = settings_create_page (book, "Identity Settings", ctree, "Identity", top, &child, index++,
				draw_identity_settings);
   vbox = settings_create_page (book, "Directory Settings", ctree, "Directory", top, &child, index++,
				draw_directory_settings); 
   vbox = settings_create_page (book, "Colors and fonts Settings", ctree, "Color & Font", top, &child, index++,
				draw_colorfont_settings);
   vbox = settings_create_page (book, "Printer Settings", ctree, "Printer", top, &child, index++,
				draw_printer_settings);
   vbox = settings_create_page (book, "Applications Settings", ctree, "Application", top, &child, index++,
				draw_application_settings);
   vbox = settings_create_page (book, "Sound Settings", ctree, "Sound", top, &child, index++, 
				draw_sound_settings);
   vbox = settings_create_page (book, "Message settings", ctree, "Message", NULL, &top, index++,
				draw_recept_settings);
   vbox = settings_create_page (book, "Reply & Forward Settings", ctree, "Reply & Forward", top, &child, index++,
				draw_sendreply_settings);
   vbox = settings_create_page (book, "Signature Settings", ctree, "Signature", top, &child, index++, 
				draw_signature_settings);
   vbox = settings_create_page (book, "Header Settings", ctree, "Header", top, &child, index++,
				draw_header_settings);
   vbox = settings_create_page (book, "Security Settings", ctree, "Security", top, &child, index++, 
				draw_security_settings);
   vbox = settings_create_page (book, "Window Settings", ctree, "Interface", top, &child, index++, 
				draw_window_settings);
   
   gtk_widget_show(book);

   /* les boutons */
   hbox = gtk_event_box_new();
   gtk_widget_show(hbox);
   gtk_widget_set_usize(GTK_WIDGET(hbox), -2, 5);
   gtk_box_pack_start(GTK_BOX(entire_widget), hbox, FALSE, TRUE, 0);

   
   hbox = gtk_hbutton_box_new ();
   gtk_widget_show (hbox);
   gtk_box_pack_start (GTK_BOX (entire_widget), hbox, FALSE, FALSE, 0);
   gtk_button_box_set_layout (GTK_BUTTON_BOX (hbox), GTK_BUTTONBOX_END);
   
   label = gtk_button_new_with_label ("OK");
   gtk_widget_show (label);
   gtk_container_add (GTK_CONTAINER (hbox), label);
   GTK_WIDGET_SET_FLAGS (label, GTK_CAN_DEFAULT);
   gtk_widget_grab_default(label);
   gtk_signal_connect_object(GTK_OBJECT(label), "clicked", GTK_SIGNAL_FUNC(option_save_settings), GTK_OBJECT(ploprc->optionWin));
   
   label = gtk_button_new_with_label ("Cancel");
   gtk_widget_show (label);
   gtk_container_add (GTK_CONTAINER (hbox), label);
   GTK_WIDGET_SET_FLAGS (label, GTK_CAN_DEFAULT);
   gtk_signal_connect_object(GTK_OBJECT(label), "clicked", gtk_widget_hide, GTK_OBJECT(ploprc->optionWin));
}



/*
 * TODO: inclure frame dans structure ACCOUNT_ENTRY
 */
void window_edit_account(gpointer data)
{
   _ACCOUNT_ENTRY *entry = malloc(sizeof(_ACCOUNT_ENTRY));
   _ACCOUNT *account = (_ACCOUNT *)data;
   GtkWidget *label, *vbox, *frame, *hbox, *vvbox, *proto, *menu, *pop_button;
   GtkObject *spin_time_to_check_adj;

#ifdef DEBUG
	if(data)
		printf("%s\n%s\n%s\n%s\n", account->name, account->host, account->username, account->password);
#endif

   entry->window = gtk_window_new(GTK_WINDOW_DIALOG);
   if(account)
	   gtk_window_set_title(GTK_WINDOW(entry->window), "Editing account");
   else
	   gtk_window_set_title(GTK_WINDOW(entry->window), "New account");
   gtk_window_set_position(GTK_WINDOW(entry->window), GTK_WIN_POS_CENTER);
   gtk_widget_set_usize(entry->window, 320, 300);
   gtk_window_set_policy (GTK_WINDOW (entry->window), FALSE, FALSE, FALSE);
   gtk_signal_connect_object(GTK_OBJECT(entry->window), "delete-event", GTK_SIGNAL_FUNC(window_edit_account_close), (gpointer)entry);

   
   vvbox = gtk_vbox_new(FALSE, 0);
   gtk_widget_show(vvbox);
   gtk_container_add(GTK_CONTAINER(entry->window), vvbox);
   
   frame = gtk_frame_new("Server: ");
   gtk_container_set_border_width (GTK_CONTAINER (frame), 6);
   gtk_frame_set_label_align (GTK_FRAME (frame), 0.08, 0.5);
   gtk_box_pack_start_defaults(GTK_BOX(vvbox), frame);
   gtk_widget_show(frame);

   vbox = gtk_vbox_new(FALSE, 0);
   gtk_widget_show(vbox);
   gtk_container_set_border_width(GTK_CONTAINER(vbox), 5);
   gtk_container_add(GTK_CONTAINER(frame), vbox);
   
   hbox = gtk_hbox_new(FALSE, 0);
   gtk_widget_show(hbox);
   gtk_box_pack_start_defaults(GTK_BOX(vbox), hbox);

   
   label = gtk_label_new("Host: ");
   gtk_widget_set_usize(label, 80, -2);
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show(label);
   gtk_box_pack_start_defaults(GTK_BOX(hbox), label);
   
   entry->host = gtk_entry_new();
   if(account)
	if(account->host)
		gtk_entry_set_text(GTK_ENTRY(entry->host), account->host);
   gtk_widget_show(entry->host);
   gtk_box_pack_start_defaults(GTK_BOX(hbox), entry->host);
   
   hbox = gtk_hbox_new(FALSE, 0);
   gtk_widget_show(hbox);
   gtk_box_pack_start_defaults(GTK_BOX(vbox), hbox);
   
   label = gtk_label_new("Type: ");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show(label);
   gtk_box_pack_start_defaults(GTK_BOX(hbox), label);
   
   proto = gtk_option_menu_new();
   gtk_box_pack_start(GTK_BOX(hbox), proto, TRUE, TRUE, 5);

   menu = gtk_menu_new();
   pop_button = gtk_menu_item_new_with_label("POP3");
   gtk_signal_connect_object(GTK_OBJECT(pop_button), "activate", GTK_SIGNAL_FUNC(option_proto_change_pop3), (gpointer)entry);
   gtk_menu_append(GTK_MENU(menu), pop_button);
   gtk_widget_show(pop_button);

   label = gtk_menu_item_new_with_label("IMAP");
   gtk_signal_connect_object(GTK_OBJECT(label), "activate", GTK_SIGNAL_FUNC(option_proto_change_imap), (gpointer)entry);
   gtk_menu_append(GTK_MENU(menu), label);
   gtk_widget_show(label);

   gtk_option_menu_set_menu(GTK_OPTION_MENU(proto), menu);
   gtk_widget_show(proto);

   label = gtk_label_new("Port: ");
   gtk_widget_show(label);
   gtk_box_pack_start_defaults(GTK_BOX(hbox), label);

   entry->port = gtk_entry_new();
   gtk_widget_show(entry->port);
   gtk_box_pack_start_defaults(GTK_BOX(hbox), entry->port);
   gtk_widget_set_usize(entry->port, 30, -2);

   frame = gtk_frame_new("Connect as: ");
   gtk_container_set_border_width (GTK_CONTAINER (frame), 6);
   gtk_frame_set_label_align (GTK_FRAME (frame), 0.08, 0.5);
   gtk_box_pack_start_defaults(GTK_BOX(vvbox), frame);
   gtk_widget_show(frame);

   vbox = gtk_vbox_new(FALSE, 0);
   gtk_widget_show(vbox);
   gtk_container_set_border_width(GTK_CONTAINER(vbox), 5);
   gtk_container_add(GTK_CONTAINER(frame), vbox);

   hbox = gtk_hbox_new(FALSE, 0);
   gtk_widget_show(hbox);
   gtk_box_pack_start_defaults(GTK_BOX(vbox), hbox);
   
   label = gtk_label_new("Username: ");
   gtk_widget_set_usize(label, 80, -2);
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show(label);
   gtk_box_pack_start_defaults(GTK_BOX(hbox), label);
   
   entry->username = gtk_entry_new();
   //gtk_entry_set_text(GTK_ENTRY(entry->username), account->username);
   gtk_widget_show(entry->username);
   gtk_box_pack_start_defaults(GTK_BOX(hbox), entry->username);

   
   hbox = gtk_hbox_new(FALSE, 0);
   gtk_widget_show(hbox);
   gtk_box_pack_start_defaults(GTK_BOX(vbox), hbox);
   
   label = gtk_label_new("Password: ");
   gtk_widget_set_usize(label, 80, -2);
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_widget_show(label);
   gtk_box_pack_start_defaults(GTK_BOX(hbox), label);
   
   entry->password = gtk_entry_new();
   //gtk_entry_set_text(GTK_ENTRY(entry->password), account->passwd);
   gtk_entry_set_visibility (GTK_ENTRY (entry->password), FALSE);
   gtk_widget_show(entry->password);
   gtk_box_pack_start_defaults(GTK_BOX(hbox), entry->password);
   
   
   frame = gtk_frame_new("Options:");
   gtk_container_set_border_width (GTK_CONTAINER (frame), 6);
   gtk_frame_set_label_align (GTK_FRAME (frame), 0.08, 0.5);
   gtk_box_pack_start_defaults(GTK_BOX(vvbox), frame);
   gtk_widget_show(frame);

   vbox = gtk_vbox_new(FALSE, 0);
   gtk_widget_show(vbox);
   gtk_container_set_border_width(GTK_CONTAINER(vbox), 5);
   gtk_container_add(GTK_CONTAINER(frame), vbox);


   hbox = gtk_hbox_new(FALSE, 0);
   gtk_widget_show(hbox);
   gtk_box_pack_start_defaults(GTK_BOX(vbox), hbox);
   
   entry->remember = gtk_check_button_new_with_label ("Remember password.");
   //if(strlen(account->passwd))
    // gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry->remember), 1);
   //else
     gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry->remember), 0);
   gtk_widget_show (entry->remember);
   gtk_box_pack_start_defaults(GTK_BOX (hbox), entry->remember);

   hbox = gtk_hbox_new(FALSE, 0);
   gtk_widget_show(hbox);
   gtk_box_pack_start_defaults(GTK_BOX(vbox), hbox);

   entry->leave = gtk_check_button_new_with_label ("Leave mail on server.");
   //if(account->leave)
     //gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry->leave), account->leave);
   gtk_widget_show (entry->leave);
   gtk_box_pack_start_defaults(GTK_BOX (hbox), entry->leave);
   
   hbox = gtk_hbox_new(FALSE, 0);
   gtk_widget_show(hbox);
   gtk_box_pack_start_defaults(GTK_BOX(vbox), hbox);
   
   entry->every = gtk_check_button_new_with_label ("Check mail every:");
   //if(account->every)
     //gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry->every), account->every);
   gtk_widget_show (entry->every);
   gtk_box_pack_start (GTK_BOX (hbox), entry->every, FALSE, FALSE, 0);
   
   spin_time_to_check_adj = gtk_adjustment_new (5.0, 1.0, 120.0, 1, 5.0, 10);
   entry->time = gtk_spin_button_new (GTK_ADJUSTMENT (spin_time_to_check_adj), 1, 0);
   //if(account->time)
     //gtk_spin_button_set_value(GTK_SPIN_BUTTON(entry->time), account->time);
   gtk_widget_show (entry->time);
   gtk_spin_button_set_shadow_type(GTK_SPIN_BUTTON(entry->time), GTK_SHADOW_OUT);
   gtk_spin_button_set_wrap(GTK_SPIN_BUTTON(entry->time), TRUE);
   gtk_box_pack_start(GTK_BOX (hbox), entry->time, FALSE, TRUE, 16);
   
   label = gtk_label_new("minutes.");
   gtk_widget_show(label);
   gtk_box_pack_end_defaults(GTK_BOX(hbox), label);
   
   label = gtk_hbutton_box_new ();
   gtk_widget_show (label);
   gtk_box_pack_start (GTK_BOX (vvbox), label, FALSE, TRUE, 0);
   gtk_button_box_set_layout (GTK_BUTTON_BOX (label), GTK_BUTTONBOX_END);
   
   hbox = gtk_button_new_with_label ("OK");
   gtk_widget_show (hbox);
   gtk_container_add (GTK_CONTAINER (label), hbox);
   GTK_WIDGET_SET_FLAGS (hbox, GTK_CAN_DEFAULT);
   gtk_signal_connect(GTK_OBJECT(hbox), "clicked", NULL, NULL);
   //gtk_signal_connect_object(GTK_OBJECT(hbox), "clicked",
//			     GTK_SIGNAL_FUNC(save_pop_settings), (GtkObject *)entry);
   
   vbox = gtk_button_new_with_label ("Cancel");
   gtk_widget_show (vbox);
   gtk_container_add (GTK_CONTAINER (label), vbox);
   GTK_WIDGET_SET_FLAGS (vbox, GTK_CAN_DEFAULT);
   gtk_signal_connect_object(GTK_OBJECT(vbox), "clicked", GTK_SIGNAL_FUNC(window_edit_account_close), (gpointer)entry);

   gtk_signal_emit_by_name(GTK_OBJECT(pop_button), "activate");
   gtk_widget_show(entry->window);
}

