#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <unistd.h>
#include <fcntl.h>

typedef struct {
	char *to;
	char *from;
	char *subject;
	char *date;
	u_int size;
	char *text;
} _MAIL;


char **split_line(char *);
void fetch_field(_MAIL *, char **);
char *nextword(char *);
int mread(int, char *, size_t);

off_t offset = 0; //
int tmp = 0;

int mail(int ac, char *av[])
{
	char **field;
	char buffer[1024];
	int f;
	_MAIL *mail = (_MAIL *)malloc(sizeof(_MAIL));

	bzero(mail, sizeof(_MAIL));

	f = open("/home/jym/mail.2", O_RDONLY);

	while(mread(f, buffer, sizeof(buffer)) > 0) {
		if(strstr(buffer, "Return-Path:")) tmp = 0;
		if(strlen(buffer) == 0) {
			if(tmp == 0) {
				if(mail->to && mail->from && mail->subject && mail->date)
				printf("MAIL '%s' DE %s POUR %s LE %s\n", mail->subject, mail->from, mail->to, mail->date);
			}
			tmp = 1;
		}
		switch(tmp) {
			case 0:
				field = split_line(buffer);
				//printf("%s :: %s\n", field[0], field[1]);
				fetch_field(mail, field);
				break;
			case 1:
				puts(buffer);
		}
	}


	close(f);

	return 0;
}


char **split_line(char *line)
{
	char *sep;
	char **field = (char **)malloc(2*sizeof(char *));

	field[0] = (char *)malloc(56);
	field[1] = (char *)malloc(256);

	if((sep = strchr(line, ':')) && (*(++sep) == ' ')) {
		strlcpy(field[0], line, (size_t)(sep - line));
		strlcpy(field[1], sep+1, strlen(sep)+1);
	} else {
		strlcpy(field[1], line, strlen(line)+1);
	}

	return field;
}

void fetch_field(_MAIL *mail, char **field)
{
	char *c = field[0];
	if(*c++ == 'T' && *c++ == 'o') {
		mail->to = (char *)malloc(strlen(field[1])+1);
		strlcpy(mail->to, field[1], strlen(field[1])+1);
	}
	c = field[0];
	if(*c++ == 'F' && *c++ == 'r' && *c++ == 'o' && *c++ == 'm') {
		mail->from = (char *)malloc(strlen(field[1])+1);
		strlcpy(mail->from, field[1], strlen(field[1])+1);
	}
	c = field[0];
	if(*c++ == 'D' && *c++ == 'a' && *c++ == 't' && *c++ == 'e') {
		mail->date = (char *)malloc(strlen(field[1])+1);
		strlcpy(mail->date, field[1], strlen(field[1])+1);
	}
	c = field[0];
	if(*c++ == 'S' && *c++ == 'u' && *c++ == 'b' && *c++ == 'j' && *c++ == 'e' && *c++ == 'c' && *c++ == 't') {
		mail->subject = (char *)malloc(strlen(field[1])+1);
		strlcpy(mail->subject, field[1], strlen(field[1])+1);
	}
}


int mread(int fd, char *buf, size_t size)
{
   int lu;
   char *kiki = (char *)malloc(size+1);
   
   if (!kiki) {
      printf("%s,%i: Out of memory!\n", __FILE__, __LINE__);
      exit(EXIT_FAILURE);
   }
     
   bzero(kiki, size+1); 
   if((lu = pread(fd, kiki, size, offset)) <= 0) {
      return lu;
   }

   for(lu = 0; lu < size; lu++) {
      if(kiki[lu] == '\r') {
	 buf[lu] = ' ';
	 continue;
      } else if ((kiki[lu] == '\n')) {
	 buf[lu++] = 0;
	 break;
      } else
      buf[lu] = kiki[lu];
   }

   offset += lu;
   free(kiki);   
   return lu+1;
}
 
