/* PLOP!
 * (C) 1999
 * ESI/Supinfo
 * 
 * $Id: plop.c,v 1.2 2001/11/08 18:25:05 jym Exp $
 * 
 * -------------------------------------------
 * 
 * Moulin Jean-Yves	(jym@ldh.org)
 * 
 * -------------------------------------------
 * 
 * This is Free Software (see COPYING for details)
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include "cfg.h"
#include "callback.h"
#include "pop3.h"
#include "interface.h"
#include "conf.h"
#include "plop.h"

#ifdef USE_PIXMAP
# include "pixmaps/check.xpm"
# include "pixmaps/new.xpm"
# include "pixmaps/delete.xpm"
# include "pixmaps/reply.xpm"
# include "pixmaps/forward.xpm"
# include "pixmaps/print.xpm"
# include "pixmaps/option.xpm"
# include "pixmaps/people.xpm"
# include "pixmaps/inbox.xpm"
# include "pixmaps/outbox.xpm"
# include "pixmaps/read.xpm"
# include "pixmaps/noread.xpm"
# include "pixmaps/trash_empty.xpm"
# include "pixmaps/account.xpm"
#endif

extern GdkColor colors[];
_USER_RC *userrc;
_PLOP_RC *ploprc;


static GtkItemFactoryEntry main_menu[] = {
     {"/File",                     NULL,            NULL, 0, "<Branch>"},
     {"/File/tearoff1          ",  NULL,            NULL, 0, "<Tearoff>" },
     {"/File/Empty trash       ",  NULL,            NULL, 0, NULL},
     {"/File/Folder/New        ",  NULL,            NULL, 0, "<Title>" },
     {"/File/Folder/Delete     ",  NULL,            NULL, 0, "<Title>" },
     {"/File/Folder/sep6"       ,  NULL,            NULL, 0, "<Separator>" },
     {"/File/Folder/Rename     ",  NULL,            NULL, 0, "<Title>" },
     {"/File/Folder/Empty      ",  NULL,            NULL, 0, "<Title>" },
     {"/File/Folder/Mark as all read",  NULL,       NULL, 0, "<Title>" },
     {"/File/sep0              ",  NULL,            NULL, 0, "<Separator>" },
     {"/File/Quit              ",  NULL,            gtk_main_quit, 0, NULL },
     {"/Message"                ,  NULL,            NULL, 0, "<Branch>"},
     {"/Message/tearoff2"       ,  NULL,            NULL, 0, "<Tearoff>"},
     {"/Message/New            ",  "<control>+N",   mail_new, 0, NULL},
     {"/Message/Reply          ",  "<control>+R",   mail_reply, 0, "<Title>"},
     {"/Message/Reply to all   ",  NULL,            mail_reply_all, 0, "<Title>"},
     {"/Message/Forward        ",  "<control>+F",   mail_forward, 0, "<Title>"},
     {"/Message/sep1"           ,  NULL,            NULL, 0, "<Separator>"},
     {"/Message/Sort by.../By date", NULL,          plop_list_mail_sort, 3, NULL},
     {"/Message/Sort by.../By subject", NULL,       plop_list_mail_sort, 1, NULL},
     {"/Message/Sort by.../By sender", NULL,        plop_list_mail_sort, 2, NULL},
     {"/Message/Save as...     ",  "<control>+S",   NULL, 0, "<Title>"},
     {"/Message/Print          ",  NULL,            NULL, 0, "<Title>"},
     {"/Message/Delete         ",  "<delete>",      plop_list_mail_delete_row, 0, NULL},
     {"/Message/sep2"           ,  NULL,            NULL, 0, "<Separator>"},
     {"/Message/Mark as read   ",  NULL,            NULL, 0, "<Title>"},
     {"/Message/Mark as unread ",  NULL,            NULL, 0, "<Title>"},
     {"/Message/sep3"           ,  NULL,            NULL, 0, "<Separator>"},
     {"/Message/Properties     ",  NULL,            NULL, 0, "<Title>"},
     {"/Tools"                  ,  NULL,            NULL, 0, "<Branch>"},
     {"/Tools/tearoff3         ",  NULL,            NULL, 0, "<Tearoff>" },
     {"/Tools/Preview mail...  ",  NULL,            NULL, 0, "<Title>"},
     {"/Tools/Send unsent mail ",  "<alternate>+S", NULL, 0, "<Title>"},
     {"/Tools/(Un)Hide detail panel", NULL,         show_hide_detail_panel, 0, NULL},
     {"/Tools/sep4"             ,  NULL,            NULL, 0, "<Separator>"},
     {"/Tools/Preferences      ",  "<control>+O",   option_window_show, 0, NULL},
     {"/Tools/Adress book      ",  NULL,            NULL, 0, "<Title>"},
     {"/Tools/Messages Rules   ",  NULL,            NULL, 0, "<Title>"},
     {"/Tools/Logs             ",  NULL,            NULL, 0, "<Title>"},
     {"/Check..."               ,  NULL,            NULL, 0, "<Branch>"},
     {"/Check.../tearoff4      ",  NULL,            NULL, 0, "<Tearoff>" },
     {"/Check.../All mailbox   ",  "<alternate>+A", check_all_mailbox, 0, NULL},
     {"/Check.../Local mailbox ",  "<alternate>+L", check_local_mail, 0, NULL},
     {"/Check.../sep5"          ,  NULL,            NULL, 0, "<Separator>"},
     {"/Help"                   ,  NULL,            NULL, 0, "<LastBranch>"},
     {"/Help/tearoff5          ",  NULL,            NULL, 0, "<Tearoff>" },
     {"/Help/About             ",  NULL,            show_about, 0, NULL},
};
#define NUMBER_OF_ENTRY 47



/*
 * Fonction principale
 * Cree la fenetre de plop
 */
int main(int argc, char *argv[])
{
   GtkWidget *pixmap;
   GdkPixmap *xpm;
   GdkBitmap *mask;
   //extern char *attach_xpm[];
   GtkWidget *table, *box, *label;
   GtkWidget *hpaned, *vpaned;
   GtkWidget *scrolledwindow; 
   GtkWidget *menubar;
   GtkWidget *toolbar;
   GtkWidget *button; 
   GtkWidget *popup_folder;
   GtkStyle *style;
   GtkItemFactory *item_factory;
   GtkAccelGroup *accel_group;
   GtkWidget *hbox;

   gint index;
   GtkCTreeNode *top, *child;
   GtkWidget *book, *vbox;

   
	/*
	 * initialisation de gtk
	 */
   
	if(!gtk_init_check(&argc, &argv)) {
		puts("*** ERROR: can't init display!");
		return -1;
	}

	/*
	 * lecture de la conf
	 */
	userrc = (_USER_RC *)malloc(sizeof(_USER_RC));
	bzero(userrc, sizeof(_USER_RC));
	ploprc = (_PLOP_RC *)malloc(sizeof(_PLOP_RC));
	bzero(ploprc, sizeof(_PLOP_RC));

	if(init_rc()) {
		puts("Can't read and init settings!");
		return -1;
	}


	/*
	 * si fichier ressource present
	 */
	if(userrc->plopGtkrcFile)
		if(strlen(userrc->plopGtkrcFile))
			gtk_rc_parse(userrc->plopGtkrcFile);
   
#ifdef DEGROBUG
   fprintf(stderr, "Creating plop window...\n");
#endif

   ploprc->plopWin = gtk_window_new (GTK_WINDOW_TOPLEVEL);
   gtk_window_set_default_size(GTK_WINDOW(ploprc->plopWin), 500, 400);
   gtk_widget_set_usize (ploprc->plopWin, 386, 58);
   gtk_window_set_title (GTK_WINDOW (ploprc->plopWin), "Plop!");
   gtk_window_set_wmclass(GTK_WINDOW(ploprc->plopWin), "PLOP mailreader", "plop"); 
   gtk_signal_connect(GTK_OBJECT(ploprc->plopWin), "destroy", GTK_SIGNAL_FUNC(gtk_main_quit), NULL);
   gtk_signal_connect(GTK_OBJECT(ploprc->plopWin), "delete_event", GTK_SIGNAL_FUNC(gtk_main_quit), NULL);
   gtk_widget_realize(ploprc->plopWin);
   
   
   table = gtk_table_new (4, 2, FALSE);
   gtk_widget_show (table);
   gtk_container_add (GTK_CONTAINER (ploprc->plopWin), table);
   
   hpaned = gtk_hpaned_new ();
   gtk_widget_show (hpaned);
   gtk_table_attach (GTK_TABLE (table), hpaned, 0, 2, 2, 3, (GtkAttachOptions) GTK_EXPAND | GTK_FILL | GTK_SHRINK, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
   gtk_paned_set_position(GTK_PANED(hpaned), 110);
   
#ifdef DEGROBUG
   fprintf(stderr, "Creating folder list...\n");
#endif
   // liste des repertoires (inbox, outbox...)
   
   scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
   gtk_widget_show (scrolledwindow);
   gtk_container_add (GTK_CONTAINER (hpaned), scrolledwindow);
   gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC); // scroll horizontal ?

   //la page de gauche avec les repertoires.
   ploprc->plopTreeFolder = GTK_CTREE(gtk_ctree_new(1, 0));
   gtk_clist_set_selection_mode (GTK_CLIST (ploprc->plopTreeFolder), GTK_SELECTION_BROWSE);
   gtk_ctree_set_line_style (ploprc->plopTreeFolder, GTK_CTREE_LINES_DOTTED);
   gtk_widget_set_sensitive (GTK_WIDGET (ploprc->plopTreeFolder), TRUE);
   gtk_ctree_set_indent (GTK_CTREE (ploprc->plopTreeFolder), 15);
   gtk_clist_set_row_height(GTK_CLIST(ploprc->plopTreeFolder), 16);
   gtk_container_add (GTK_CONTAINER (scrolledwindow), GTK_WIDGET (ploprc->plopTreeFolder));
   gtk_widget_show (GTK_WIDGET(ploprc->plopTreeFolder));

   // utile ?? depend de l'initialisation
   ploprc->plopListMailSortFlag = 0;
   
   vpaned = gtk_vpaned_new ();
   gtk_widget_show (vpaned);
   gtk_container_add (GTK_CONTAINER (hpaned), vpaned);
   gtk_paned_set_position(GTK_PANED(vpaned), 110);
   
   ploprc->plopPopupMenuMail = plop_create_popup_menu_mail();   

   book = gtk_notebook_new ();
   gtk_notebook_set_show_tabs (GTK_NOTEBOOK (book), FALSE);
   gtk_notebook_set_show_border (GTK_NOTEBOOK (book), FALSE);
   gtk_container_add (GTK_CONTAINER (vpaned), book);
   gtk_object_set_user_data (GTK_OBJECT (ploprc->plopTreeFolder), book);
   gtk_signal_connect (GTK_OBJECT (ploprc->plopTreeFolder), "tree_select_row", 
		       GTK_SIGNAL_FUNC (plop_tree_folder_select), NULL);
   index = 0;
   vbox = plop_create_page (book, GTK_WIDGET(ploprc->plopTreeFolder), "Inbox", NULL, &top, index++, plop_draw_inbox, inbox_xpm);
   gtk_ctree_select (GTK_CTREE (ploprc->plopTreeFolder), top);
   vbox = plop_create_page (book, GTK_WIDGET(ploprc->plopTreeFolder), "Outbox", NULL, &top, index++, plop_draw_outbox, outbox_xpm);
   vbox = plop_create_page (book, GTK_WIDGET(ploprc->plopTreeFolder), "Unfinished", NULL, &top, index++, plop_draw_inbox, read_xpm);
   vbox = plop_create_page (book, GTK_WIDGET(ploprc->plopTreeFolder), "Trash", NULL, &top, index++, plop_draw_trash, trash_empty_xpm);

   // EXAMPLE
   vbox = plop_create_page (book, GTK_WIDGET(ploprc->plopTreeFolder), "Ecole", NULL, &top, index++, plop_draw_inbox, NULL);

   vbox = plop_create_page (book, GTK_WIDGET(ploprc->plopTreeFolder), "Prepa-2", top, &child, index++, plop_draw_inbox, NULL);
   // FIN EXAMPLE

   
   
   gtk_widget_show(book);

   
#ifdef DEGROBUG
   fprintf(stderr, "Creating popup menu...\n");
#endif
   
   // menu popup
   popup_folder = plop_create_popup_menu_dir();
   gtk_signal_connect_object(GTK_OBJECT(ploprc->plopTreeFolder), "button_press_event", GTK_SIGNAL_FUNC (plop_folder_popup_handler), GTK_OBJECT(popup_folder));

	{
		GtkWidget *tmp;
#ifdef DEGROBUG
   fprintf(stderr, "Creating detail panel...\n");
#endif

   box = gtk_vbox_new(FALSE, 0);
   gtk_widget_show(box);
   gtk_container_add(GTK_CONTAINER(vpaned), box);

   ploprc->plopDetailPanel = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(box), ploprc->plopDetailPanel, FALSE, FALSE, 0);
   
   tmp = gtk_vbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(ploprc->plopDetailPanel), tmp, TRUE, TRUE, 5);
   gtk_widget_set_usize(tmp, -2, 20);
   gtk_widget_show(tmp);

   hbox = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(tmp), hbox, TRUE, TRUE, 2);
   gtk_widget_show(hbox);
   
   label = gtk_label_new("Subject: ");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
   //gtk_widget_set_usize(label, 80, 20);
   gtk_widget_show(label);

   style = gtk_style_new();
   style->fg[0] = colors[2];
   style->font = gdk_font_load ("-*-helvetica-medium-r-normal--10-*-*-*-*-*-*-*");

#ifdef DEBUG
	ploprc->plopLabelSubject = gtk_label_new("New release: v0.1!");
#else
   ploprc->plopLabelSubject = gtk_label_new("");
#endif
   gtk_widget_show(ploprc->plopLabelSubject);
   gtk_box_pack_start(GTK_BOX(hbox), ploprc->plopLabelSubject, FALSE, FALSE, 0);
   gtk_misc_set_alignment(GTK_MISC(ploprc->plopLabelSubject), 0.0f, 0.5f);
   gtk_widget_set_style(ploprc->plopLabelSubject, style);

   hbox = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(tmp), hbox, TRUE, TRUE, 2);
   gtk_widget_show(hbox);

   label = gtk_label_new("Date: ");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
   //gtk_widget_set_usize(label, 80, 20);
   gtk_widget_show(label);

#ifdef DEBUG
   ploprc->plopLabelDate = gtk_label_new("13 mai 2001");
#else
   ploprc->plopLabelDate = gtk_label_new("");
#endif
   gtk_widget_show(ploprc->plopLabelDate);
   gtk_box_pack_start(GTK_BOX(hbox), ploprc->plopLabelDate, FALSE, FALSE, 0);
   gtk_widget_set_style(ploprc->plopLabelDate, style);
   
   tmp = gtk_vbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(ploprc->plopDetailPanel), tmp, TRUE, TRUE, 5);
   //gtk_widget_set_usize(hbox, -2, 20);
   gtk_widget_show(tmp);

   hbox = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(tmp), hbox, TRUE, TRUE, 2);
   gtk_widget_show(hbox);

   label = gtk_label_new("From: ");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
   //gtk_widget_set_usize(label, 80, 20);
   gtk_widget_show(label);

#ifdef DEBUG
   ploprc->plopLabelFrom = gtk_label_new("Jean-Yves Moulin <jym@supinfo.com>");
#else
   ploprc->plopLabelFrom = gtk_label_new("");
#endif
   gtk_widget_show(ploprc->plopLabelFrom);
   gtk_box_pack_start(GTK_BOX(hbox), ploprc->plopLabelFrom, FALSE, FALSE, 0);
   gtk_widget_set_style(ploprc->plopLabelFrom, style);
   
   hbox = gtk_hbox_new(FALSE, 0);
   gtk_box_pack_start(GTK_BOX(tmp), hbox, TRUE, TRUE, 2);
   gtk_widget_show(hbox);

   label = gtk_label_new("To: ");
   gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
   gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, FALSE, 0);
   //gtk_widget_set_usize(label, 80, 20);
   gtk_widget_show(label);
   
#ifdef DEBUG
   ploprc->plopLabelTo = gtk_label_new("Jean-Yves Moulin <jym@ldh.org>");
#else
   ploprc->plopLabelTo = gtk_label_new("");
#endif
   gtk_widget_show(ploprc->plopLabelTo);
   /* verifier */
   gtk_box_pack_start(GTK_BOX(hbox), ploprc->plopLabelTo, FALSE, FALSE, 0);
   gtk_widget_set_style(ploprc->plopLabelTo, style);

   /*
   ploprc->plopAttachment = gtk_button_new();
   gtk_widget_show(ploprc->plopAttachment);
   gtk_box_pack_end(GTK_BOX(hbox), ploprc->plopAttachment, FALSE, TRUE, 0);
   gtk_button_set_relief(GTK_BUTTON(ploprc->plopAttachment), GTK_RELIEF_NONE);
   
#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d(ploprc->plopWin->window,  &mask, NULL, attach_xpm );
   label = gtk_pixmap_new( xpm, mask );
#else
   label = gtk_label_new("Attach");
#endif
   gtk_container_add(GTK_CONTAINER(ploprc->plopAttachment), label);
   gtk_signal_connect_object(GTK_OBJECT(ploprc->plopAttachment), "clicked", GTK_SIGNAL_FUNC(plop_show_attachment), GTK_OBJECT(ploprc->plopAttachment));
   gtk_widget_show(label);
*/
	}


   /* fenetre d'affichage des mail */
#ifdef DEGROBUG
   fprintf(stderr, "Creating text window...\n");
#endif
   scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
   gtk_widget_show (scrolledwindow);
   gtk_box_pack_start_defaults(GTK_BOX(box), scrolledwindow);
   gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
   
   ploprc->plopText = gtk_text_new (NULL, NULL);
   gtk_widget_show (ploprc->plopText);
   gtk_container_add (GTK_CONTAINER (scrolledwindow), ploprc->plopText);
   
   /* creation de la barre de menu */
   box = gtk_handle_box_new ();
   gtk_widget_show (box);
   gtk_table_attach (GTK_TABLE (table), box, 0, 2, 0, 1, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);

#ifdef DEGROBUG
   fprintf(stderr, "Creating menubar...\n");
#endif
   accel_group = gtk_accel_group_new();
   item_factory = gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<main>", accel_group);
   gtk_item_factory_create_items(item_factory, NUMBER_OF_ENTRY, main_menu, NULL);
   gtk_accel_group_attach(accel_group, GTK_OBJECT(ploprc->plopWin));
   
   menubar = gtk_item_factory_get_widget(item_factory, "<main>");
   gtk_container_add (GTK_CONTAINER (box), menubar);
   gtk_widget_show(menubar);
   ploprc->plopCheckMenu = gtk_item_factory_get_widget(item_factory, "/Check...");

   /* on est obliger de dessiner les menu APRES avoir recuperer le menu "Check.." */
	g_list_foreach(userrc->list_account, plop_menu_redrawn, NULL);
   
   /* toolbar (vous savez, la barre avec toutes les icones) */
#ifdef DEGROBUG
   fprintf(stderr, "Creating toolbar...\n");
#endif
   box = gtk_handle_box_new ();
   gtk_widget_show (box);
   gtk_table_attach (GTK_TABLE (table), box, 0, 2, 1, 2, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);
   
   toolbar = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, 
#ifdef USE_PIXMAP
			      GTK_TOOLBAR_ICONS);
#else
   GTK_TOOLBAR_TEXT);
#endif

   gtk_container_add (GTK_CONTAINER (box), toolbar);
   gtk_widget_show (toolbar);
   
   gtk_container_border_width (GTK_CONTAINER (toolbar), 2);
   gtk_toolbar_set_button_relief (GTK_TOOLBAR (toolbar), GTK_RELIEF_NONE);
   gtk_toolbar_set_space_style (GTK_TOOLBAR(toolbar), 1);
   gtk_toolbar_set_space_size (GTK_TOOLBAR (toolbar), 10);

#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->plopWin->window,  &mask, &ploprc->plopWin->style->bg[GTK_STATE_NORMAL], check_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
#endif
   button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_CHILD_BUTTON, NULL, "Check mail", "Check All mailbox", NULL, pixmap, NULL, NULL);
   gtk_signal_connect_object(GTK_OBJECT(button), "clicked", check_all_mailbox, NULL);
   gtk_widget_show (button);
   
   gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));

#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->plopWin->window,  &mask, NULL, new_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
#endif
   button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_CHILD_BUTTON, NULL, "New mail", "New message", NULL, pixmap, NULL, NULL);
   gtk_signal_connect_object(GTK_OBJECT(button), "clicked", mail_new, NULL);
   gtk_widget_show (button);
   
#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->plopWin->window,  &mask, &ploprc->plopWin->style->white, reply_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
#endif
   button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_CHILD_BUTTON, NULL, "Reply", "Reply to author", NULL, pixmap, NULL, NULL); 
gtk_widget_show (button);
   
#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->plopWin->window,  &mask, &ploprc->plopWin->style->white, forward_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
#endif
   button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_CHILD_BUTTON, NULL, "Forward", "Forward message", NULL, pixmap, NULL, NULL);
   gtk_widget_show (button);
   
#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->plopWin->window,  &mask, &ploprc->plopWin->style->white, delete_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
#endif
   button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_CHILD_BUTTON, NULL, "Delete", "Delete selected message", NULL, pixmap, NULL, NULL);
   gtk_widget_show (button);
   
#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->plopWin->window,  &mask, &ploprc->plopWin->style->white, print_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
#endif
   button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_CHILD_BUTTON, NULL, "Print", "Print selected message", NULL, pixmap, NULL, NULL);
   gtk_widget_show (button);
   
   gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));
   
#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->plopWin->window,  &mask, &ploprc->plopWin->style->white, people_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
#endif
   button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_CHILD_BUTTON, NULL, "Address book", "Adress book", NULL, pixmap, NULL, NULL);
   gtk_widget_show (button);
   
   gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));
   
#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->plopWin->window,  &mask, &ploprc->plopWin->style->white, option_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
#endif
   button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_CHILD_BUTTON, NULL, "Options", "Preference", NULL, pixmap, NULL, NULL);
   gtk_widget_show (button);
   gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(option_window_show), NULL);

/*
#ifdef USE_PIXMAP
   xpm = gdk_pixmap_create_from_xpm_d( ploprc->plopWin->window,  &mask, &ploprc->plopWin->style->white, account_xpm );
   pixmap = gtk_pixmap_new( xpm, mask );
#endif
   button = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_CHILD_BUTTON, NULL, "Account", "Open account window", NULL, pixmap, NULL, NULL);
   gtk_widget_show (button);
   gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(show_account_window), NULL);
*/


#ifdef DEGROBUG
   fprintf(stderr, "Creating statusbar...\n");
#endif
   /* barre d'activite */
   ploprc->plopProgressBar = gtk_progress_bar_new ();
   gtk_widget_show (ploprc->plopProgressBar);
   gtk_table_attach (GTK_TABLE (table), ploprc->plopProgressBar, 1, 2, 3, 4, (GtkAttachOptions) GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);
   gtk_widget_set_usize (ploprc->plopProgressBar, 50, 20);
   gtk_progress_set_activity_mode (GTK_PROGRESS (ploprc->plopProgressBar), 1);
   
   /* barrre de status */
   ploprc->plopStatusBar = gtk_statusbar_new ();
   gtk_widget_show (ploprc->plopStatusBar);
   gtk_table_attach (GTK_TABLE (table), ploprc->plopStatusBar, 0, 1, 3, 4, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);
   
  
   /* on cree la fenetre d'options */
   create_option_window();


   if (userrc->plopDetailPanelVisibility) {
      gtk_widget_show(ploprc->plopDetailPanel);
   }

   /* c fini!*/
   gtk_statusbar_push (GTK_STATUSBAR (ploprc->plopStatusBar), 1, "");
   gtk_widget_show(ploprc->plopWin);
   
#ifdef DEGROBUG
   fprintf(stderr, "All are done!\n");
#endif
   
   gtk_main();

   cfg_set_bool(userrc->plopDetailPanelVisibility, "/plop/other/view_detail");
   cfg_sync();

#ifdef DEBUG
   puts("free user and internal var");
#endif

   g_list_foreach(userrc->list_account, free_account, NULL);
   g_list_free(userrc->list_account);
   free(ploprc);
   free(userrc);

   return 0;
}


/* EOF */
